SystemOrganization addCategory: #'PolySource-Chat'!
SystemOrganization addCategory: #'PolySource-Core'!
SystemOrganization addCategory: #'PolySource-ControlPanel'!
SystemOrganization addCategory: #'PolySource-Model'!
SystemOrganization addCategory: #'PolySource-Morphic'!
SystemOrganization addCategory: #'PolySource-Network'!
SystemOrganization addCategory: #'PolySource-Tests'!

SystemDictionary subclass: #PSSystemDictionary
	instanceVariableNames: 'organization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemDictionary commentStamp: 'mt 8/29/2010 19:23:48.53' prior: 0!
I am a copy of the local SystemDictionary (Smalltalk globals) but I do not copy the classes. I provide my own organization.!

!PSSystemDictionary class methodsFor: 'constants' stamp: 'mt 10/1/2010 11:43:32.372'!
sharedClasses

	^ #(ProtoObject)! !

!PSSystemDictionary methodsFor: 'initialize' stamp: 'mt 10/1/2010 12:07:04.804'!
initialize: size

	super initialize: size.
	Smalltalk globals keysAndValuesDo: [ :symbol :classTraitOrGlobal |
		(classTraitOrGlobal isBehavior and: [classTraitOrGlobal isTrait not])
			ifTrue: [(self class sharedClasses includes: symbol)
				ifTrue: [self at: symbol put: classTraitOrGlobal]
				ifFalse: [self at: symbol put: classTraitOrGlobal copy]]
			ifFalse: [(PSSystemDictionaryProxy sharedGlobals includes: symbol)
				ifFalse: [self at: symbol put: classTraitOrGlobal]]].
	
	"Subclasses are nil but will be covered in PSRemoteClient. Now fix superclasses."
	self keysAndValuesDo: [:symbol :classTraitOrGlobal |
		(classTraitOrGlobal isBehavior
			and: [classTraitOrGlobal isTrait not]
			and: [classTraitOrGlobal superclass notNil]
			and: [(self class sharedClasses includes: symbol) not])
			ifTrue: [classTraitOrGlobal superclass: (self at: classTraitOrGlobal superclass name)]].! !

!SystemDictionary methodsFor: '*polysource-core' stamp: 'mt 8/29/2010 19:32:52.227'!
isProxy

	^ false! !

Dictionary subclass: #PSFixtures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

PSFixtures class
	instanceVariableNames: 'instance'!

!PSFixtures commentStamp: 'mt 10/1/2010 10:32:47.45' prior: 0!
Offers instances to be used in tests. Generates some classes on initialization time.!

PSFixtures class
	instanceVariableNames: 'instance'!

!PSFixtures class methodsFor: 'class initialization' stamp: 'mt 10/1/2010 10:38:13.047'!
initialize

	super initialize.
	
	self
		initializeFixtureClasses;
		initializeExample01.! !

!PSFixtures class methodsFor: 'class initialization' stamp: 'mt 10/1/2010 10:38:49.148'!
initializeExample01

	"Need a proxy to get the class compiled into the right dictionary."
	PSSystemDictionaryProxy install.

	PSCurrentRemoteClient
		value: (PSFixtures instance at: #example01 put: PSRemoteClient new)
		during: [Object
			subclass: #PSFoobar
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'PolySource-Tests-Temporary'].

	"Test data prepared. Clean up."
	PSSystemDictionaryProxy uninstall.! !

!PSFixtures class methodsFor: 'class initialization' stamp: 'mt 10/1/2010 10:41:37.056'!
initializeFixtureClasses

	Object subclass: #XYPlayer instanceVariableNames: 'score' classVariableNames: '' poolDictionaries: '' category: 'XYGame'.
	Object subclass: #XYEnemy instanceVariableNames: 'strength' classVariableNames: '' poolDictionaries: '' category: 'XYGame'.
	
	(Smalltalk at: #XYPlayer) compile: 'score
	^ score' classified: #accessing; comment: 'Auto-generated via PSFixtures class. Is used by PolySource tests.'.
	(Smalltalk at: #XYEnemy) compile: 'strength
	^ strength' classified: #accessing; comment: 'Auto-generated via PSFixtures class. Is used by PolySource tests.'.
	
	"Register new package."
	PackageInfo named: #XYGame.
! !

!PSFixtures class methodsFor: 'singleton' stamp: 'mig 8/9/2010 17:29:05.257'!
instance

	^ instance ifNil: [instance := self new]! !

PasteUpMorph subclass: #PSRemoteWorld
	instanceVariableNames: 'remoteClient infoLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Morphic'!

!PSRemoteWorld commentStamp: 'mt 9/7/2010 12:15:36.029' prior: 0!
A remote world has a remote world state and a remote client. =D!

!PSRemoteWorld class methodsFor: 'project' stamp: 'mt 9/7/2010 12:03:27.714'!
newWorldForProject: projectOrNil 

	^ self new initForProject: PSRemoteWorldState new! !

!PSRemoteWorld methodsFor: 'world menu' stamp: 'mt 10/1/2010 16:24:40.47'!
buildWorldMenu: evt
	^(PSRemoteWorldMenu new
		world: self
		project: (self project ifNil: [Project current])       "mvc??"
		hand: evt hand) buildWorldMenu.! !

!PSRemoteWorld methodsFor: 'initialize' stamp: 'mt 9/7/2010 13:12:04.365'!
initialize

	super initialize.
	self
		color: (Color gray: 0.8);
		borderWidth: 0.
		
	infoLabel := TextMorph new lock.
	self addMorphBack: infoLabel.
	infoLabel topLeft: self topLeft + (20@50).
	
	self connect: self signal: #remoteClient: toSelector: #updateInfoLabel.
	self updateInfoLabel.! !

!PSRemoteWorld methodsFor: 'world menu' stamp: 'mt 10/1/2010 16:24:35.333'!
openWorldMenu
	| menu |
	menu := (PSRemoteWorldMenu new adaptToWorld: self) buildWorldMenu.
	menu addTitle: Preferences desktopMenuTitle translated.
	menu openInHand! !

!PSRemoteWorld methodsFor: 'accessing' stamp: 'mt 9/6/2010 11:26:10.299'!
remoteClient

	^ remoteClient! !

!PSRemoteWorld methodsFor: 'accessing' stamp: 'mt 9/7/2010 12:18:58.166'!
remoteClient: aRemoteClient

	remoteClient := aRemoteClient.! !

!PSRemoteWorld methodsFor: 'initialize' stamp: 'mt 9/7/2010 13:13:07.697'!
updateInfoLabel

	infoLabel contents: 
		(self remoteClient
			ifNil: ['<font size="12" color="#FF0000"><b>No remote client configured.</b></font>' asHtmlText]
			ifNotNil: ['']).! !

!PSRemoteWorld methodsFor: 'accessing' stamp: 'mt 9/7/2010 13:15:56.106'!
worldState
	"Needed to grant access to deferred UI message queue. See PSRemoteWorldState>>deferredUIMessages."
	
	^ worldState! !

TheWorldMenu subclass: #PSRemoteWorldMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Morphic'!

!PSRemoteWorldMenu methodsFor: 'construction' stamp: 'mt 10/3/2010 11:32:05.79'!
addObjectsAndTools: menu
	self
		fillIn: menu
		from: {
			nil.
			{ 'objects (o)'. { #myWorld. #activateObjectsTool }. 'A tool for finding and obtaining many kinds of objects' }.
			{ 'new morph...'. { self. #newMorph }. 'Offers a variety of ways to create new objects' }.
			nil.
		}! !

!PSRemoteWorldMenu methodsFor: 'construction' stamp: 'mt 10/3/2010 11:30:47.025'!
addProjectEntries: menu
	self
		fillIn: menu
		from: {
			nil.
			{ 'back to local project'. { #myWorld. #goBack }. 'return to the most-recently-visited project' }.
			nil
		}! !

!PSRemoteWorldMenu methodsFor: 'construction' stamp: 'mt 10/3/2010 11:34:09.127'!
addUtilities: menu

	self
		fillIn: menu
		from: {
			{ 'open...'. { self. #openWindow } }.
			{ 'do...'. { Utilities. #offerCommonRequests }. 'put up an editible list of convenient expressions, and evaluate the one selected.' }
		}.! !

!PSRemoteWorldMenu methodsFor: 'construction' stamp: 'mt 10/3/2010 11:32:33.903'!
buildWorldMenu
	"Build the menu that is put up when the screen-desktop is clicked on"
	| menu |
	menu := MenuMorph new defaultTarget: self.
	menu commandKeyHandler: self.
	self colorForDebugging: menu.
	menu addStayUpItem.
	self makeConvenient: menu.
	Smalltalk at: #ServiceGUI ifPresent:[:sgui|
		sgui worldMenu: menu.
		sgui onlyServices ifTrue: [^ menu].
	].
	self addProjectEntries: menu.
"	myWorld addUndoItemsTo: menu."
	self addRestoreDisplay: menu.
	self addUtilities: menu.
	self addObjectsAndTools: menu.
	self addPrintAndDebug: menu.
"	self addSaveAndQuit: menu."
	^ menu! !

!Class methodsFor: '*polysource-core-override' stamp: 'mt 9/17/2010 12:29:35.721'!
addSubclass: aSubclass 
	"Make the argument, aSubclass, be one of the subclasses of the receiver. 
	Create an error notification if the argument's superclass is not the receiver."
	
	aSubclass superclass ~~ self 
		ifTrue: [^self error: aSubclass name , ' is not my subclass'].
		
	PSCurrentRemoteClient value ifNotNil: [:rc |
		rc addSubclass: aSubclass to: self.
		^ self].
		
	subclasses == nil
		ifTrue:	[subclasses := Array with: aSubclass.
				^self].
	subclasses do:[:cl| cl == aSubclass ifTrue:[^self]]. "Already my subclass"
	subclasses := subclasses copyWith: aSubclass.! !

!Class methodsFor: '*polysource-core-override' stamp: 'mt 9/17/2010 12:29:26.653'!
removeSubclass: aSubclass 
	"If the argument, aSubclass, is one of the receiver's subclasses, remove it."

	PSCurrentRemoteClient value ifNotNil: [:rc |
		rc removeSubclass: aSubclass from: self.
		^ self].

	subclasses == nil ifFalse:
		[subclasses :=  subclasses copyWithout: aSubclass.
		subclasses isEmpty ifTrue: [subclasses := nil]].
! !

!Class methodsFor: '*polysource-core-override' stamp: 'mt 9/17/2010 12:26:53.921'!
subclasses
	"Answer a Set containing the receiver's subclasses."

	PSCurrentRemoteClient value ifNotNil: [:rc |
		^ rc subclassesFor: self].

	^subclasses == nil
		ifTrue: [#()]
		ifFalse: [subclasses copy]! !

!Class methodsFor: '*polysource-core-override' stamp: 'mt 9/17/2010 12:28:11.493'!
subclassesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the receiver's immediate subclasses."
	
	| tmp |
	tmp := self subclasses.
	tmp ifNotEmpty: [tmp do: aBlock].! !

!Class methodsFor: '*polysource-core-override' stamp: 'mt 9/17/2010 12:28:40.475'!
subclassesDoGently: aBlock 
	"Evaluate the argument, aBlock, for each of the receiver's immediate subclasses."
	
	self subclassesDo: aBlock.! !

!Class methodsFor: '*polysource-core-override' stamp: 'mt 9/17/2010 12:30:25.087'!
superclass: aClass methodDictionary: mDict format: fmt
	"Basic initialization of the receiver"
	
	super superclass: aClass methodDictionary: mDict format: fmt.
	
	PSCurrentRemoteClient value ifNotNil: [:rc |
		rc resetSubclassesFor: self.
		^ self].
	
	subclasses := nil. "Important for moving down the subclasses field into Class"
! !

SwaGeneralScrollPane subclass: #PSChatScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Chat'!

!PSChatScrollPane methodsFor: 'geometry' stamp: 'mt 9/13/2010 10:34:16.337'!
extent: aPoint

	self scrollTarget ifNotNilDo: [:morph | morph width: aPoint x - (self vScrollbarNeeded ifTrue: [self scrollbarThickness] ifFalse: [0])].
	super extent: aPoint.! !

!PSChatScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 9/13/2010 09:15:33.799'!
hScrollbarNeeded

	^ false! !

!PSChatScrollPane methodsFor: 'initialization' stamp: 'mt 9/18/2010 15:40:58.335'!
initialize

	super initialize.
	self
		width: PSChatListMorph defaultWidth + self scrollBarThickness; 
		height: 500;
		color: Color white;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1; color: Color gray).
		! !

!PSChatScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 9/13/2010 14:32:55.907'!
scrollTarget: aMorph

	super scrollTarget: aMorph.
	
	(aMorph isKindOf: PSChatListMorph) ifTrue: [
		self
			connect: aMorph signal: #focusChanged: toSelector: #scrollToShow:;
			connect: aMorph signal: #resized toSelector: #updateScrollbars;
			connect: aMorph signal: #resized toSelector: #updateListExtent].! !

!PSChatScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 9/13/2010 09:29:08.777'!
scrollToShow: aRectangle
	"Scroll to include as much of aRectangle as possible, where aRectangle is in the scroller's local space."
	
	|offset|
	offset := self scroller offset.
	(aRectangle top - offset y) < 0
		ifTrue: [offset := offset x @ (
					(aRectangle top min: self scrollTarget height - self innerBounds height))].
	(aRectangle bottom - offset y) > self innerBounds height
		ifTrue: [offset := offset x @ (
					(aRectangle top - self innerBounds height + aRectangle height min: self scrollTarget height - self innerBounds height))].
		
	offset = self scroller offset ifFalse: [
		self scroller offset: offset.
		self setScrollDeltas]! !

!PSChatScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 9/13/2010 13:47:31.817'!
updateListExtent

	self scrollTarget ifNotNilDo: [:morph | morph width: self extent x - (self vScrollbarNeeded ifTrue: [self scrollbarThickness] ifFalse: [0])].! !

!SystemEventManager methodsFor: '*polysource-core' stamp: 'mt 9/9/2010 14:53:23.684'!
actionMap

	^ PSCurrentRemoteClient value
		ifNil: [super actionMap]
		ifNotNil: [PSCurrentRemoteClient value systemEventActionMap]! !

!SystemEventManager methodsFor: '*polysource-core' stamp: 'mt 9/16/2010 12:12:16.63'!
releaseActionMap

	self actionMap removeAll.! !

!SystemEventManager methodsFor: '*polysource-core' stamp: 'mt 9/9/2010 14:54:24.674'!
updateableActionMap

	^ PSCurrentRemoteClient value
		ifNil: [super updateableActionMap]
		ifNotNil: [PSCurrentRemoteClient value systemEventActionMap]! !

SqEntity subclass: #PSChatEntity
	instanceVariableNames: 'author timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSChatEntity class methodsFor: 'instance creation' stamp: 'mt 9/13/2010 14:44:12.842'!
new

	^ super new
		author: Utilities authorInitials;
		timestamp: TimeStamp now.! !

!PSChatEntity methodsFor: 'accessing' stamp: 'mt 9/13/2010 14:43:11.755'!
author

	^ author! !

!PSChatEntity methodsFor: 'accessing' stamp: 'mt 9/13/2010 14:43:13.355'!
author: aString

	author := aString.! !

!PSChatEntity methodsFor: 'accessing' stamp: 'mt 9/13/2010 15:02:09.43'!
timestamp

	^ timestamp! !

!PSChatEntity methodsFor: 'accessing' stamp: 'mt 9/13/2010 14:43:18.7'!
timestamp: aTimeStamp

	timestamp := aTimeStamp.! !

PSChatEntity subclass: #PSChatMessage
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSChatMessage class methodsFor: 'instance creation' stamp: 'mt 9/13/2010 14:44:34.678'!
message: aText

	^ self new message: aText! !

!PSChatMessage methodsFor: 'accessing' stamp: 'mt 9/13/2010 14:35:01.677'!
message

	^ message! !

!PSChatMessage methodsFor: 'accessing' stamp: 'mt 9/13/2010 14:34:55.494'!
message: aText

	message := aText.! !

PSChatEntity subclass: #PSChatNotification
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSChatNotification class methodsFor: 'instance creation' stamp: 'mt 9/13/2010 14:44:31.089'!
event: aSystemEvent

	^ self new event: aSystemEvent! !

!PSChatNotification methodsFor: 'converting' stamp: 'mt 9/19/2010 21:01:32.532'!
asIcon
	"Format this notification as a form resp. icon."
	
	self event isString ifTrue: [^ UiSilkIcons informationIcon].
	self event isText ifTrue: [^ UiSilkIcons informationIcon].
	
	self event itemKind = AbstractEvent categoryKind ifTrue: [
		self event isAdded ifTrue: [^ UiSilkIcons packageAddIcon].
		"self event isModified ?"
		self event isRemoved ifTrue: [^ UiSilkIcons packageDeleteIcon].
		self event isRenamed ifTrue: [^ UiSilkIcons packageGreenIcon]].
	
	self event itemKind = AbstractEvent classKind ifTrue: [
		self event isAdded ifTrue: [^ UiSilkIcons carAddIcon].
		self event isCommented ifTrue: [^ UiSilkIcons noteIcon].
		self event isModified ifTrue: [^ UiSilkIcons carIcon].
		self event isRecategorized ifTrue: [^ UiSilkIcons packageGoIcon].
		self event isRemoved ifTrue: [^ UiSilkIcons carDeleteIcon].
		self event isRenamed ifTrue: [^ UiSilkIcons tagGreenIcon].
		self event isReorganized ifTrue: [^ UiFugueIcons cardsStackIcon]].
	
	self event itemKind = AbstractEvent methodKind ifTrue: [
		self event isAdded ifTrue: [^ UiSilkIcons scriptAddIcon].
		self event isModified ifTrue: [^ UiSilkIcons scriptEditIcon].
		self event isRecategorized ifTrue: [^ UiSilkIcons scriptGoIcon].
		self event isRemoved ifTrue: [^ UiSilkIcons scriptDeleteIcon]].! !

!PSChatNotification methodsFor: 'converting' stamp: 'mt 9/19/2010 20:20:57.067'!
asString

	^ self asText asString! !

!PSChatNotification methodsFor: 'converting' stamp: 'mt 9/20/2010 15:09:57.849'!
asText
	"Format this notification as a text object."
	
	self event isString ifTrue: [^ self event asText append: (' (by <b>', self author, '</b>)') asHtmlText].
	self event isText ifTrue: [^ self event copy append: (' (by <b>', self author, '</b>)') asHtmlText].
	
	self event itemKind = AbstractEvent categoryKind ifTrue: [
		self event isAdded ifTrue: [^ ('System category <b>', self event item,'</b> added by <b>', self author, '</b>.') asHtmlText].
		"self event isModified ?"
		self event isRemoved ifTrue: [^ ('System category <b>', self event item,'</b> removed by <b>', self author, '</b>.') asHtmlText].
		self event isRenamed ifTrue: [^ ('System category renamed from <b>', self event oldName,'</b> to <b>', self event newName, '</b> by <b>', self author, '</b>.') asHtmlText]].
	
	self event itemKind = AbstractEvent classKind ifTrue: [
		self event isAdded ifTrue: [^ ('Class <b>', self eventItemClass, '</b> added by <b>', self author, '</b>.') asHtmlText].
		self event isCommented ifTrue: [^ ('Class <b>', self eventItemClass, '</b> commented by <b>', self author, '</b>.') asHtmlText].
		self event isModified ifTrue: [^ ('Class <b>', self eventItemClass, '</b> modified by <b>', self author, '</b>.') asHtmlText].
		self event isRecategorized ifTrue: [^ ('Class <b>', self event item, '</b> recategorized from <b>', self event oldCategory, '</b> into <b>', self event itemCategory, '</b> by <b>', self author, '</b>.') asHtmlText].
		self event isRemoved ifTrue: [^ ('Class <b>', self event item, '</b> removed by <b>', self author, '</b>.') asHtmlText].
		self event isRenamed ifTrue: [^ ('Class renamed from <b>', self event oldName, '</b> to <b>', self event newName, '</b> by <b>', self author, '</b>.') asHtmlText].
		self event isReorganized ifTrue: [^ ('Class <b>', self eventItemClass, '</b> reorganized, i.e. protocols modified, by <b>', self author, '</b>.') asHtmlText]].
	
	self event itemKind = AbstractEvent methodKind ifTrue: [
		self event isAdded ifTrue: [^ ('Method <b>#', self eventItemMethod, '</b> (', self eventItemClass, ') added by <b>', self author, '</b>.') asHtmlText].
		self event isModified ifTrue: [^ ('Method <b>#', self eventItemMethod, '</b> (', self eventItemClass, ') modified by <b>', self author, '</b>.') asHtmlText].
		self event isRecategorized ifTrue: [^ ('Method <b>#', self event item, '</b> (', self eventItemClass, ') recategorized from <b>', self event oldCategory, '</b> into <b>', self event itemProtocol, '</b> by <b>', self author, '</b>.') asHtmlText].
		self event isRemoved ifTrue: [^ ('Method <b>#', self eventItemMethod, '</b> (', self eventItemClass, ') removed by <b>', self author, '</b>.') asHtmlText]].! !

!PSChatNotification methodsFor: 'accessing' stamp: 'mt 9/13/2010 14:38:05.543'!
event

	^ event! !

!PSChatNotification methodsFor: 'accessing' stamp: 'mt 9/13/2010 14:38:00.68'!
event: anEvent

	event := anEvent.! !

!PSChatNotification methodsFor: 'accessing' stamp: 'mt 9/19/2010 20:33:54.546'!
eventItemClass

	^ (self event instVarNamed: #environment) at: AbstractEvent classKind! !

!PSChatNotification methodsFor: 'accessing' stamp: 'mt 9/19/2010 20:34:01.316'!
eventItemMethod

	^ (self event instVarNamed: #environment) at: AbstractEvent methodKind! !

SqEntity subclass: #PSChatStatus
	instanceVariableNames: 'timestamp message needsHelp isOnline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSChatStatus methodsFor: 'testing' stamp: 'mt 9/19/2010 11:03:32.548'!
isOnline

	^ isOnline notNil
		and: [isOnline]
		and: [self timestamp notNil]
		and: [(self timestamp to: TimeStamp now) duration asSeconds < 120]! !

!PSChatStatus methodsFor: 'accessing' stamp: 'mt 9/19/2010 10:31:22.069'!
isOnline: aBoolean

	isOnline := aBoolean.! !

!PSChatStatus methodsFor: 'accessing' stamp: 'mt 9/19/2010 10:28:19.306'!
message

	^ message! !

!PSChatStatus methodsFor: 'accessing' stamp: 'mt 9/19/2010 10:28:25.47'!
message: aText

	message := aText.! !

!PSChatStatus methodsFor: 'testing' stamp: 'mt 9/20/2010 15:28:51.214'!
needsHelp

	^ needsHelp ifNil: [false]! !

!PSChatStatus methodsFor: 'accessing' stamp: 'mt 9/19/2010 10:27:46.081'!
needsHelp: aBoolean

	needsHelp := aBoolean.! !

!PSChatStatus methodsFor: 'accessing' stamp: 'mt 9/19/2010 10:34:09.471'!
timestamp
	"Can be used to retrieve a 'last seen' time."
	
	^ timestamp! !

!PSChatStatus methodsFor: 'accessing' stamp: 'mt 9/19/2010 12:10:13.929'!
timestamp: aTimeStamp

	timestamp := aTimeStamp.
	isOnline := true. "Workaround for SqSync bug. Calling #isOnline: induces too much ApplyMessages."! !

SqEntity subclass: #PSSourceCode
	instanceVariableNames: 'uuid snapshot updates packages author chat lastPing chatStatus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSSourceCode methodsFor: 'chat - add/remove' stamp: 'mt 9/19/2010 20:00:46.736'!
addChatMessage: aChatMessage

	<replicate>

	self chat add: aChatMessage.
	self chatMessageAdded: aChatMessage.! !

!PSSourceCode methodsFor: 'chat - add/remove' stamp: 'mt 9/19/2010 20:00:39.518'!
addChatNotification: aChatNotification

	<replicate>

	self chat add: aChatNotification.
	self chatNotificationAdded: aChatNotification.! !

!PSSourceCode methodsFor: 'add/remove' stamp: 'mt 9/20/2010 11:23:26.066'!
addPackage: aSymbol

	<replicate>
	
	(self packages includes: aSymbol)
		ifTrue: [^ aSymbol].
	
	self packages add: aSymbol.
	self packageAdded: aSymbol.
	
	^ aSymbol! !

!PSSourceCode methodsFor: 'add/remove' stamp: 'mt 9/20/2010 11:23:31.763'!
addUpdate: aCodeUpdate

	<replicate>

	self updates add: aCodeUpdate.
	self updateAdded: aCodeUpdate.
	
	^ aCodeUpdate! !

!PSSourceCode methodsFor: 'chat - accessing' stamp: 'mt 9/13/2010 14:29:59.781'!
author

	^ author! !

!PSSourceCode methodsFor: 'chat - accessing' stamp: 'mt 9/19/2010 10:19:48.517'!
author: aString

	author := aString.! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 9/10/2010 12:04:14.175'!
categories

	^ self packages
		inject: OrderedCollection new
		into: [:categories :package | 
			categories addAll: (PackageInfo named: package) systemCategories.
			categories]! !

!PSSourceCode methodsFor: 'chat - accessing' stamp: 'mt 9/13/2010 14:41:00.557'!
chat

	^ chat! !

!PSSourceCode methodsFor: 'chat - signals' stamp: 'mt 9/13/2010 14:41:13.372'!
chatMessageAdded: aChatMessage

	self emitAlways.! !

!PSSourceCode methodsFor: 'chat - signals' stamp: 'mt 9/13/2010 14:41:23.518'!
chatNotificationAdded: aChatNotification

	self emitAlways.! !

!PSSourceCode methodsFor: 'chat - accessing' stamp: 'mt 9/19/2010 10:29:10.699'!
chatStatus

	^ chatStatus! !

!PSSourceCode methodsFor: 'chat - accessing' stamp: 'mt 9/19/2010 11:39:48.744'!
chatStatus: aChatStatus

	chatStatus := aChatStatus.! !

!PSSourceCode methodsFor: 'chat - status' stamp: 'mt 9/19/2010 10:33:42.774'!
goOffline

	self chatStatus isOnline: false.! !

!PSSourceCode methodsFor: 'initialize' stamp: 'mt 9/19/2010 11:37:35.349'!
initialize

	super initialize.

	packages := OrderedCollection new.
	updates := OrderedCollection new.
	chat := OrderedCollection new.! !

!PSSourceCode methodsFor: 'chat - status' stamp: 'mt 9/20/2010 15:26:32.717'!
isOnline

	^ self chatStatus notNil and: [self chatStatus isOnline]! !

!PSSourceCode methodsFor: 'chat - status' stamp: 'mt 9/20/2010 16:26:43.338'!
needsHelp

	^ self chatStatus notNil and: [self chatStatus needsHelp]! !

!PSSourceCode methodsFor: 'signals' stamp: 'mt 9/10/2010 10:55:18.753'!
packageAdded: aSymbol

	self emitAlways.! !

!PSSourceCode methodsFor: 'signals' stamp: 'mt 9/10/2010 10:55:24.035'!
packageRemoved: aSymbol

	self emitAlways.! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 9/10/2010 10:56:11.02'!
packages

	^ packages! !

!PSSourceCode methodsFor: 'chat - status' stamp: 'mt 9/19/2010 11:31:29.948'!
ping: aTimeStamp

	self chatStatus timestamp: aTimeStamp.
	self pinged.! !

!PSSourceCode methodsFor: 'chat - signals' stamp: 'mt 9/18/2010 17:15:06.587'!
pinged

	self emitAlways.! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 8/30/2010 13:26:57.291'!
snapshot

	^ snapshot! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 9/8/2010 09:19:56.387'!
snapshot: aCodeSnapshot

	snapshot := aCodeSnapshot.
	updates := OrderedCollection new.
	self snapshotChanged: snapshot.! !

!PSSourceCode methodsFor: 'signals' stamp: 'mt 9/8/2010 09:19:43.855'!
snapshotChanged: newSnapshot

	self emitAlways.! !

!PSSourceCode methodsFor: 'signals' stamp: 'mt 9/8/2010 09:20:46.905'!
updateAdded: anUpdate

	self emitAlways.! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 9/7/2010 14:40:19.878'!
updates

	^ updates! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 8/30/2010 15:26:59.314'!
uuid

	^ uuid! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 8/30/2010 15:27:09.666'!
uuid: aUUID

	uuid := aUUID.! !

SqEntity subclass: #PSSourceCodeRepository
	instanceVariableNames: 'sourceCodes packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSSourceCodeRepository methodsFor: 'add/remove' stamp: 'mt 9/20/2010 11:21:40.336'!
addPackage: aPackageName

	<replicate>

	(self packages includes: aPackageName)
		ifTrue: [^ aPackageName].
	
	self packages add: aPackageName.
	self sourceCodes do: [:src | src addPackage: aPackageName].

	^ aPackageName! !

!PSSourceCodeRepository methodsFor: 'add/remove' stamp: 'mt 9/20/2010 11:27:21.469'!
addSourceCode: aSourceCode

	<replicate>

	(self sourceCodes includes: aSourceCode)
		ifTrue: [^ aSourceCode].

	self sourceCodes add: aSourceCode.
	self sourceCodeAdded: aSourceCode.
	
	self packages do: [:pkg | aSourceCode addPackage: pkg].
	
	^ aSourceCode! !

!PSSourceCodeRepository methodsFor: 'initialize-release' stamp: 'mt 9/20/2010 11:15:58.548'!
initialize

	super initialize.
	sourceCodes := OrderedCollection new.
	packages := OrderedCollection new.! !

!PSSourceCodeRepository methodsFor: 'accessing' stamp: 'mt 9/20/2010 11:24:41.738'!
packages

	^ packages! !

!PSSourceCodeRepository methodsFor: 'add/remove' stamp: 'mt 9/20/2010 11:22:24.523'!
removePackage: aPackageName

	<replicate>

	self packages remove: aPackageName ifAbsent: [].
	^ aPackageName! !

!PSSourceCodeRepository methodsFor: 'add/remove' stamp: 'mt 9/20/2010 11:22:34.179'!
removeSourceCode: aSourceCode

	<replicate>

	self sourceCode remove: aSourceCode ifAbsent: [^ aSourceCode].
	self sourceCodeRemoved: aSourceCode.
	^ aSourceCode! !

!PSSourceCodeRepository methodsFor: 'signals' stamp: 'mt 9/8/2010 10:05:52.445'!
sourceCodeAdded: aSourceCode

	self emitAlways.! !

!PSSourceCodeRepository methodsFor: 'signals' stamp: 'mt 9/8/2010 10:06:42.983'!
sourceCodeRemoved: aSourceCode

	self emitAlways.! !

!PSSourceCodeRepository methodsFor: 'accessing' stamp: 'mt 9/7/2010 14:39:10.491'!
sourceCodes

	^ sourceCodes! !

SqEntity subclass: #PSSourceCodeUpdate
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSSourceCodeUpdate methodsFor: 'accessing' stamp: 'mt 9/8/2010 08:48:39.234'!
event
	
	^ event! !

!PSSourceCodeUpdate methodsFor: 'accessing' stamp: 'mt 9/9/2010 10:03:15.36'!
event: aSystemEvent
	
	event := aSystemEvent.! !

!PSSourceCodeUpdate methodsFor: 'accessing' stamp: 'mt 9/7/2010 19:48:34.865'!
eventItemClass

	^ (self event instVarNamed: #environment) at: AbstractEvent classKind! !

!PSSourceCodeUpdate methodsFor: 'accessing' stamp: 'mt 9/7/2010 19:48:44.886'!
eventItemMethod

	^ (self event instVarNamed: #environment) at: AbstractEvent methodKind! !

Object subclass: #PSChatClientListModel
	instanceVariableNames: 'currentClientIndex lastOnlineStatus lastClientNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Chat'!

!PSChatClientListModel commentStamp: 'mt 9/18/2010 15:15:54.998' prior: 0!
I am a model for the list of available clients.!

!PSChatClientListModel methodsFor: 'updating' stamp: 'mt 9/20/2010 15:31:19.235'!
checkClientNames

	| clientNames |
	clientNames := Array streamContents: [:strm | self clients do: [:rc | 
		strm nextPut: rc sourceCode author]].
	lastClientNames = clientNames ifTrue: [^ self].
	lastClientNames := clientNames.

	"Update the list."
	self changed: #clientNames.! !

!PSChatClientListModel methodsFor: 'updating' stamp: 'mt 9/20/2010 13:40:22.12'!
checkOnlineStatus

	| onlineStatus |
	onlineStatus := Array streamContents: [:strm | self clients do: [:rc | 
		rc needsHelp
			ifTrue: [strm nextPut: #needsHelp]	
			ifFalse: [strm nextPut: rc isOnline]]].
	lastOnlineStatus = onlineStatus ifTrue: [^ self].
	lastOnlineStatus := onlineStatus.

	"Update the list."
	self changed: #clientNames.! !

!PSChatClientListModel methodsFor: 'accessing' stamp: 'mt 9/20/2010 15:58:09.285'!
clientNames

	^ self clients collect: [:rc |
		rc isOnline
			ifTrue: [rc sourceCode author = self sourceCode author
				ifTrue: [(rc sourceCode author, ' <font color="#AAAAAA">owner</font>') asHtmlText]
				ifFalse: [rc sourceCode author]]
			ifFalse: [('<font color="#AAAAAA">', rc sourceCode author, '</font>') asHtmlText]].! !

!PSChatClientListModel methodsFor: 'accessing - private' stamp: 'mt 9/18/2010 17:48:02.663'!
clients

	^ PSLocalClient instance remoteClients ifNil: [#()]! !

!PSChatClientListModel methodsFor: 'accessing' stamp: 'mt 9/18/2010 15:24:02.356'!
currentClientIndex

	^ currentClientIndex ifNil: [0]! !

!PSChatClientListModel methodsFor: 'accessing' stamp: 'mt 9/18/2010 15:36:25.631'!
currentClientIndex: anInteger

	currentClientIndex := anInteger.
	self changed: #currentClientIndex.! !

!PSChatClientListModel methodsFor: 'accessing' stamp: 'mt 9/18/2010 15:34:18.835'!
iconSize

	^ 8@8! !

!PSChatClientListModel methodsFor: 'initialize-release' stamp: 'mt 9/20/2010 11:51:06.603'!
initialize

	super initialize.
	
	self connect: PSLocalClient instance signal: #remoteClientAdded: toSelector: #checkOnlineStatus.
	self connect: PSLocalClient instance signal: #remoteClientRemoved: toSelector: #checkOnlineStatus.

	self connect: PSLocalClient instance signal: #connected toSelector: #checkOnlineStatus.
	self connect: PSLocalClient instance signal: #disconnected toSelector: #checkOnlineStatus.! !

!PSChatClientListModel methodsFor: 'accessing' stamp: 'mt 9/20/2010 15:43:13.628'!
sourceCode

	^ ((PSCurrentRemoteClient value) ifNil: [PSLocalClient instance]) sourceCode! !

!PSChatClientListModel methodsFor: 'accessing' stamp: 'mt 9/20/2010 15:35:47.471'!
statusIcons

	^ self clients collect: [:rc | 
		rc isOnline
			ifTrue: [rc needsHelp
				ifTrue: [UiFugueIcons questionSmallIcon clippedTo: 8@8]
				ifFalse: [UiSilkIcons bulletGreenIcon clippedTo: 8@8]]
			ifFalse: [nil]]! !

Object subclass: #PSSourceCodeClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Network'!

!PSSourceCodeClient commentStamp: 'mt 9/8/2010 09:21:39.726' prior: 0!
I am an abstract base class that offers convenient update and filein capabilities for source codes.!

PSSourceCodeClient subclass: #PSLocalClient
	instanceVariableNames: 'uuid connection remoteClients pingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Network'!

PSLocalClient class
	instanceVariableNames: 'instance'!

!PSLocalClient commentStamp: 'mig 9/8/2010 14:00:05.641' prior: 0!
I respresent a local PolySource "application". I hold information about the local system (UUID etc.) and the SqSync client.!

PSLocalClient class
	instanceVariableNames: 'instance'!

!PSLocalClient class methodsFor: 'instance' stamp: 'mt 9/7/2010 10:06:47.765'!
instance
	"This is the instance of PSLocalClient that has to be (re-)used in a normal application. Tests are allowed to create further instances with own SqSync connections and UUIDs."
	
	^ instance ifNil: [instance := self new]! !

!PSLocalClient class methodsFor: 'instance' stamp: 'mt 9/8/2010 11:58:34.927'!
reset
	
	instance disconnect.
	instance becomeForward: self new.
	instance uuid.! !

!PSLocalClient methodsFor: 'remote client handling' stamp: 'mt 9/9/2010 09:51:44.806'!
addRemoteClient: aSourceCode

	self remoteClients add: (PSRemoteClient new sourceCode: aSourceCode).
	self remoteClientAdded: self remoteClients last.
! !

!PSLocalClient methodsFor: 'initialize' stamp: 'mt 9/19/2010 11:39:31.057'!
assurePingProcess
	
	pingProcess isNilOrTerminated ifFalse: [^ self].
	
	"KLUDGE: Initialize and register chat status object. Workaround for SqSync bug."
	self sourceCode chatStatus ifNil: [self sourceCode chatStatus: PSChatStatus new].
	
	"Setup frequent ping."
	pingProcess := [[self sourceCode notNil] whileTrue: [
		WorldState addDeferredUIMessage: [self sourceCode ifNotNil: [:sc | sc ping: TimeStamp now]].
		(Delay forSeconds: 60) wait]] sqForkAt: 45.! !

!PSLocalClient methodsFor: 'networking' stamp: 'mt 9/12/2010 12:15:37.653'!
connectTo: aHostnameOrAddressString

	| syClient |
	self disconnect.
	
	syClient := SyClient new.
	self connect: syClient signal: #incomingNetworkTrafficChanged: toSelector: #networkTrafficChanged:.
	
	self connection: (syClient
		connectToHostNamed: aHostnameOrAddressString
		port: 22701).
		
	self connected.! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/8/2010 10:55:59.05'!
connected

	self emit.! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 8/30/2010 15:34:56.859'!
connection

	^ connection! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 9/18/2010 17:01:00.989'!
connection: anSyClient

	connection := anSyClient.
	
	connection ifNil: [^ self].
	
	"Assure the root object resp. source code repository."
	connection repository rootObject
		ifNil: [connection repository rootObject: PSSourceCodeRepository new].
	
	self createRemoteClients.
	
	self connect: self repository signal: #sourceCodeAdded: toSelector: #addRemoteClient:.
	self connect: self repository signal: #sourceCodeRemoved: toSelector: #removeRemoteClient:.
	
	"Process external updates for me."
	self connect: self sourceCode signal: #updateAdded: toSelector: #executeUpdateSilently:.
	self connect: self sourceCode signal: #snapshotChanged: toSelector: #fileInSnapshot.

	"Tell everyone about my current source code."
	self updateSnapshot.
	
	self assurePingProcess.! !

!PSLocalClient methodsFor: 'remote client handling' stamp: 'mig 9/8/2010 15:12:20.18'!
createRemoteClients

	self remoteClients: (self connection repository rootObject sourceCodes
		select: [:sc | sc uuid asString ~= self uuid asString]
		thenCollect: [:sc | PSRemoteClient new sourceCode: sc]).
! !

!PSLocalClient methodsFor: 'notifications' stamp: 'mt 9/7/2010 15:30:26.088'!
disableNotificationProcessing

	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self.! !

!PSLocalClient methodsFor: 'networking' stamp: 'mt 9/19/2010 10:34:22.097'!
disconnect

	connection ifNil: [^ self].
	
	pingProcess isNilOrTerminated ifFalse: [pingProcess terminate].
	pingProcess := nil.
	
	"Update the source code before disconnect."
	self isConnected ifTrue: [
		self updateSnapshot.
		self sourceCode goOffline.
		self connection flushCommands].
	
	"Disconnect."
	connection disconnect.
	connection := nil.
	
	self remoteClients: nil.
	
	self disconnected.! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/8/2010 10:56:01.81'!
disconnected

	self emit.! !

!PSLocalClient methodsFor: 'notifications' stamp: 'mt 10/1/2010 10:27:08.877'!
enableNotificationProcessing

	self disableNotificationProcessing.
	
	SystemChangeNotifier uniqueInstance
		notify: self ofAllSystemChangesUsing: #processNotification:.! !

!PSLocalClient methodsFor: 'update handling' stamp: 'mt 9/10/2010 10:35:54.919'!
executeUpdate: anUpdate

	PSCurrentRemoteClient
		value: nil
		during: [super executeUpdate: anUpdate].! !

!PSLocalClient methodsFor: 'snapshot handling' stamp: 'mt 9/10/2010 10:35:05.004'!
fileInSnapshot
	"Do not allow external snapshot updates for me. Defer the reaction because SqSync will not replicate the call otherwise."
	
	WorldState addDeferredUIMessage: [
		PSCurrentRemoteClient
			value: nil
			during: [self updateSnapshot]].! !

!PSLocalClient methodsFor: 'initialize' stamp: 'mt 9/18/2010 17:01:13.453'!
initialize
	
	super initialize.
	self enableNotificationProcessing.! !

!PSLocalClient methodsFor: 'testing' stamp: 'mt 9/8/2010 11:03:37.277'!
isConnected

	^ self connection notNil and: [self connection isConnected]! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/12/2010 12:13:07.445'!
networkTrafficChanged: bytesPerSecond

	self emitAlways.! !

!PSLocalClient methodsFor: 'notifications' stamp: 'mt 9/20/2010 11:37:04.268'!
processNotification: anEvent
	"Filter according to the registered categories in the source code. Then add the update."
	
	| sourceCode sourceCodeClient sourceCodeUpdate |
	anEvent isDoIt ifTrue: [^ self].
	PSReplicateSystemEvents value ifNotNil: [^ self].
	
	"Get client and source code according to dynamic scope."
	sourceCodeClient := PSCurrentRemoteClient value ifNil: [self].
	sourceCode := sourceCodeClient sourceCode.
	sourceCode ifNil: [^ self].
	
	"Check if category is of interest."
	anEvent itemKind = AbstractEvent categoryKind ifTrue: [
		(anEvent isAdded and: [(sourceCode categories includes: anEvent itemCategory) not]) ifTrue: [^ self].
		(anEvent isRenamed and: [sourceCode packages noneSatisfy: [:pkg | (PackageInfo named: pkg) includesSystemCategory: anEvent oldName]]) ifTrue: [^ self].
		(anEvent isRemoved and: [sourceCode packages noneSatisfy: [:pkg | (PackageInfo named: pkg) includesSystemCategory: anEvent itemCategory]]) ifTrue: [^ self]].
	
	anEvent itemKind ~= AbstractEvent categoryKind ifTrue: [
		(sourceCode categories includes: anEvent itemClass instanceSide category)
			ifFalse: [^ self]].
	
	"Create the update object and add it to the model."
	sourceCode disconnectSignal: #updateAdded: from: sourceCodeClient.
	
	sourceCodeUpdate := self class createUpdateFromEvent: anEvent.
	sourceCode addUpdate: sourceCodeUpdate.
	sourceCode addChatNotification: (PSChatNotification event: sourceCodeUpdate event).
	self connect: sourceCode signal: #updateAdded: to: sourceCodeClient selector: #executeUpdateSilently:.! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/9/2010 09:51:20.918'!
remoteClientAdded: aRemoteClient

	self emit.! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/9/2010 09:51:27.22'!
remoteClientRemoved: aRemoteClient

	self emit.! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mig 9/8/2010 15:06:44.581'!
remoteClients

	^ remoteClients! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 9/9/2010 09:57:30.035'!
remoteClients: someRemoteClients

	remoteClients := someRemoteClients.! !

!PSLocalClient methodsFor: 'remote client handling' stamp: 'mt 9/9/2010 09:59:26.665'!
removeRemoteClient: aSourceCode

	| oldRemoteClient |
	oldRemoteClient := self remoteClients detect: [:rc | rc sourceCode uuid = aSourceCode uuid] ifNone: [].
	self remoteClients remove: oldRemoteClient.
	self remoteClientRemoved: oldRemoteClient.
! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 9/9/2010 09:57:09.281'!
repository

	^ self connection ifNotNil: [:c | c repository rootObject]! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 9/19/2010 21:24:09.465'!
sourceCode

	| result |
	self repository ifNotNil: [:repo |
		"Due to lazy source code adding, we need to disconnect first. Slow?"
		repo disconnectSignal: #sourceCodeAdded: from: self.
		result := repo sourceCodes
			detect: [:c | c uuid asString = self uuid asString]
			ifNone: [repo addSourceCode: (PSSourceCode new uuid: self uuid)].
		self connect: repo signal: #sourceCodeAdded: toSelector: #addRemoteClient:].
	^ result! !

!PSLocalClient methodsFor: 'snapshot handling' stamp: 'mt 9/13/2010 14:47:51.086'!
updateSnapshot

	PSCurrentRemoteClient
		value: nil
		during: [
			super updateSnapshot.
			self sourceCode author: Utilities authorInitials].! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 9/8/2010 10:57:15.36'!
uuid

	^ uuid ifNil: [
		uuid := UUID new.
		self uuidGenerated: uuid.
		uuid]! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/8/2010 10:56:59.263'!
uuidGenerated: aUUID

	self emit.! !

PSSourceCodeClient subclass: #PSRemoteClient
	instanceVariableNames: 'systemDictionary systemOrganization sourceCode systemEventActionMap subclassesMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Network'!

!PSRemoteClient commentStamp: 'mt 9/8/2010 09:25:22.355' prior: 0!
I am kind of a view to the source code of a remote client. A morphic remote project uses me to define a dynamic scope to allow tools access to that source code.!

!PSRemoteClient methodsFor: 'subclasses handling' stamp: 'mt 9/30/2010 17:53:07.095'!
addSubclass: aSubclass to: aClass

	((self subclassesFor: aClass) includes: aSubclass)
		ifTrue: [^ self "Already there."].

	self subclassesMap
		at: aClass name
		put: ((self subclassesFor: aClass) copyWith: aSubclass)! !

!PSRemoteClient methodsFor: 'update handling' stamp: 'mt 9/9/2010 12:07:31.099'!
executeUpdate: anUpdate

	Smalltalk globals isProxy ifFalse: [Error signal: 'Proxy needed!!'].

	PSCurrentRemoteClient
		value: self
		during: [super executeUpdate: anUpdate].! !

!PSRemoteClient methodsFor: 'snapshot handling' stamp: 'mt 9/9/2010 16:13:21.891'!
fileInSnapshot
	
	Smalltalk globals isProxy ifFalse: [Error signal: 'Proxy needed!!'].
	
	self resetSystemVariables.
	
	PSCurrentRemoteClient
		value: self
		during: [super fileInSnapshot].! !

!PSRemoteClient methodsFor: 'private' stamp: 'mt 9/17/2010 13:04:07.131'!
hideClass: aClass

	PSCurrentRemoteClient value ifNil: [Error signal: 'Class hiding without remote client is not allowed!!'].
	
	Smalltalk globals removeKey: aClass name.
	Smalltalk globals flushClassNameCache.
	
	Smalltalk organization removeElement: aClass name.
	
	aClass superclass removeSubclass: aClass.! !

!PSRemoteClient methodsFor: 'private' stamp: 'mt 9/30/2010 10:55:12.876'!
hideClasses

	(self sourceCode notNil and: [self sourceCode packages notNil]) ifTrue: [
		PSCurrentRemoteClient
			value: self
			during: [ self sourceCode packages do: [:pkg |
				(PackageInfo named: pkg) classes do: [:class |
					self hideClass: class]]]].! !

!PSRemoteClient methodsFor: 'private' stamp: 'mt 9/30/2010 17:48:23.769'!
hideExtension: aMethodReference

	PSCurrentRemoteClient value ifNil: [Error signal: 'Class hiding without remote client is not allowed!!'].
	
	SystemChangeNotifier uniqueInstance doSilently: [
		aMethodReference actualClass organization removeElement: aMethodReference selector].
	
	aMethodReference actualClass methodDict removeKey: aMethodReference selector.! !

!PSRemoteClient methodsFor: 'private' stamp: 'mt 9/30/2010 10:58:57.1'!
hideExtensions

	(self sourceCode notNil and: [self sourceCode packages notNil]) ifTrue: [
		PSCurrentRemoteClient
			value: self
			during: [ self sourceCode packages do: [:pkg |
				(PackageInfo named: pkg) extensionMethods do: [:ref |
					self hideExtension: ref]]]].! !

!PSRemoteClient methodsFor: 'initialize' stamp: 'mt 9/30/2010 10:48:06.445'!
initialize

	super initialize.
	
	self resetSystemVariables.
	
	"Create my own copy of the system action map."
	systemEventActionMap := (SystemChangeNotifier uniqueInstance instVarNamed: #eventSource) actionMap copy
		ifNil: [IdentityDictionary new].! !

!PSRemoteClient methodsFor: 'testing' stamp: 'mt 9/19/2010 10:38:22.213'!
isOnline

	^ self sourceCode notNil and: [self sourceCode isOnline]! !

!PSRemoteClient methodsFor: 'initialize' stamp: 'mt 9/9/2010 12:07:18.98'!
loadSourceCode

	PSCurrentRemoteClient
		value: self
		during: [super loadSourceCode].! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/20/2010 17:49:30.623'!
name

	^ self sourceCode
		ifNil: [super name]
		ifNotNil: [self sourceCode author asString, ' (', self sourceCode uuid asString, ')']! !

!PSRemoteClient methodsFor: 'testing' stamp: 'mt 9/20/2010 16:27:05.708'!
needsHelp

	^ self sourceCode notNil and: [self sourceCode needsHelp]! !

!PSRemoteClient methodsFor: 'open' stamp: 'mt 9/20/2010 18:07:29.882'!
open
	"Create a remote project and open a viewer for it."
	
	| project |
	PSCurrentRemoteClient 
		value: self
		during: [
			project := PSRemoteProject new.
			PSRemoteProjectViewMorph openOn: project].! !

!PSRemoteClient methodsFor: 'subclasses handling' stamp: 'mt 9/30/2010 17:53:02.007'!
removeSubclass: aSubclass from: aClass

	self subclassesMap
		at: aClass name
		put: ((self subclassesFor: aClass) copyWithout: aSubclass).
	
	(self subclassesFor: aClass) ifEmpty: [self resetSubclassesFor: aClass].! !

!PSRemoteClient methodsFor: 'subclasses handling' stamp: 'mt 9/30/2010 17:52:57.054'!
resetSubclassesFor: aClass

	self subclassesMap removeKey: aClass name ifAbsent: [].! !

!PSRemoteClient methodsFor: 'private' stamp: 'mt 10/1/2010 12:11:07.879'!
resetSubclassesMap
	
	PSCurrentRemoteClient value ifNotNil: [Error signal: 'Recreation of the copy of the subclasses structure must happen without a remote client!!'].
	
	"Create my own copy of the subclasses structure."
	subclassesMap := Dictionary new.
	Smalltalk allClasses
		reject: [:class | class subclasses isEmpty]
		thenDo: [:class | subclassesMap at: class name asSymbol put:
			"Store class copies in the subclasses map."
			(class subclasses collect: [:subclass | | tmp |
				tmp := self systemDictionary at: subclass instanceSide name.
				subclass isMeta ifTrue: [tmp class] ifFalse: [tmp]])].! !

!PSRemoteClient methodsFor: 'initialize' stamp: 'mt 10/1/2010 10:09:29.126'!
resetSystemVariables
	
	PSCurrentRemoteClient 
		value: nil
		during: [ 
			systemDictionary := PSSystemDictionary new.
			systemOrganization := SystemOrganization deepCopy.
			self resetSubclassesMap].
	
	self
		hideClasses;
		hideExtensions.! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/6/2010 11:34:12.155'!
sourceCode

	^ sourceCode! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/9/2010 11:56:35.135'!
sourceCode: aSourceCode

	sourceCode ifNotNil: [
		sourceCode disconnectSignal: #updateAdded: from: self.
		sourceCode disconnectSignal: #snaptshotChanged: from: self].

	sourceCode := aSourceCode.
	
	sourceCode ifNotNil: [
		self loadSourceCode.
		self connect: sourceCode signal: #updateAdded: toSelector: #executeUpdateSilently:.
		self connect: sourceCode signal: #snapshotChanged: toSelector: #fileInSnapshot].! !

!PSRemoteClient methodsFor: 'subclasses handling' stamp: 'mt 9/30/2010 17:52:51.778'!
subclassesFor: aClass

	^ (self subclassesMap at: aClass name ifAbsent: [Array new]) copy! !

!PSRemoteClient methodsFor: 'subclasses handling' stamp: 'mt 9/17/2010 11:32:37.937'!
subclassesMap

	^ subclassesMap! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/6/2010 11:18:13.62'!
systemDictionary

	^ systemDictionary! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/9/2010 14:42:51.531'!
systemEventActionMap

	^ systemEventActionMap! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/6/2010 11:18:10.182'!
systemOrganization

	^ systemOrganization! !

!PSRemoteClient methodsFor: 'snapshot handling' stamp: 'mt 9/9/2010 10:00:20.26'!
updateSnapshot

	PSCurrentRemoteClient
		value: self
		during: [super updateSnapshot].! !

!PSSourceCodeClient class methodsFor: 'support' stamp: 'mt 9/9/2010 11:09:08.374'!
createUpdateFromEvent: anEvent

	| result env |
	result := anEvent copy.
	env := (anEvent instVarNamed: #environment) copy.

	"Use custom environment."
	result instVarNamed: #environment put: env.

	"Generic transformations."
	result itemClass ifNotNil: [result itemClass: result itemClass name asSymbol].
	result itemRequestor ifNotNil: [result itemRequestor: nil]. "Cannot transport requestor instance anyway."
	result itemMethod ifNotNil: [result itemMethod: result itemMethod selector].

	"Kind-Specific transformations."
	anEvent itemKind = AbstractEvent classKind ifTrue: [
		result instVarNamed: #item put: anEvent item name asSymbol. "class name by default"
		(anEvent isAdded or: [anEvent isModified])
			ifTrue: [result instVarNamed: #item put: anEvent item definition]. "class definition"
		anEvent isModified ifTrue: [result oldItem: anEvent oldItem name asSymbol]. "old class name"
		anEvent isCommented ifTrue: [result instVarNamed: #item put: anEvent item comment]. "class comment"
		anEvent isReorganized ifTrue: [
			result instVarNamed: #item put: anEvent item organization asString]. "class protocols"].
		
	anEvent itemKind = AbstractEvent methodKind ifTrue: [
		result instVarNamed: #item put: anEvent item selector. "method selector by default"
		(anEvent isAdded or: [anEvent isModified]) ifTrue: [
			result instVarNamed: #item put: (self fileOutSourceFor: anEvent item)]. "method source" 
		anEvent isModified ifTrue: [result oldItem: anEvent oldItem selector]. "old selector"].
	
	^ PSSourceCodeUpdate new event: result! !

!PSSourceCodeClient class methodsFor: 'support' stamp: 'mt 9/9/2010 10:05:34.608'!
fileOutSourceFor: aCompiledMethod
	"Better than just #getSource. Preserves Protocols."
	
	| strm |
	strm := WriteStream on: (String new: 1000).

	strm header; timeStamp.
	aCompiledMethod methodClass
		printMethodChunk: aCompiledMethod selector
		withPreamble: true
		on: strm
		moveSource: false
		toFile: 0.
		
	^ strm contents! !

!PSSourceCodeClient methodsFor: 'snapshot handling' stamp: 'mt 9/15/2010 09:51:16.997'!
addPackage: aPackageName

	self sourceCode addPackage: aPackageName.
	self updateSnapshot.! !

!PSSourceCodeClient methodsFor: 'update handling' stamp: 'mt 9/9/2010 16:04:14.61'!
executeUpdate: anUpdate

	| event |
	event := anUpdate event.
	
	event itemKind = AbstractEvent categoryKind ifTrue: [
		event isAdded ifTrue: [SystemOrganization addCategory: event item].
		"event isModified ?"
		event isRemoved ifTrue: [SystemOrganization removeSystemCategory: event item].
		event isRenamed ifTrue: [SystemOrganization renameCategory: event oldName toBe: event newName]].
	
	event itemKind = AbstractEvent classKind ifTrue: [
		event isAdded ifTrue: [Compiler evaluate: event item "class definition"].
		event isCommented ifTrue: [(Smalltalk at: anUpdate eventItemClass) comment: event item "class comment"].
		event isModified ifTrue: [Compiler evaluate: event item "modified class definition"].
		event isRecategorized ifTrue: [(Smalltalk at: anUpdate eventItemClass) category: event itemCategory].
		event isRemoved ifTrue: [(Smalltalk at: anUpdate eventItemClass) removeFromSystem].
		event isRenamed ifTrue: [(Smalltalk at: event oldName) rename: event newName].
		event isReorganized ifTrue: [(Smalltalk at: anUpdate eventItemClass) organization changeFromString: event item "class protocols"]].
	
	event itemKind = AbstractEvent methodKind ifTrue: [
		(event isAdded or: [event isModified]) ifTrue: [(ReadStream on: event item) fileIn "method fileOut source with timeStamps and protocols a.s.o."].
		event isRecategorized ifTrue: [(Smalltalk at: anUpdate eventItemClass) organization classify: event item under: event itemProtocol].
		event isRemoved ifTrue: [(Smalltalk at: anUpdate eventItemClass) removeSelector: event item]].! !

!PSSourceCodeClient methodsFor: 'update handling' stamp: 'mt 9/9/2010 11:00:23.765'!
executeUpdateSilently: anUpdate

	PSReplicateSystemEvents
		value: false
		during: [self executeUpdate: anUpdate].! !

!PSSourceCodeClient methodsFor: 'snapshot handling' stamp: 'mt 9/18/2010 17:54:33.935'!
fileInSnapshot
	"Load the source of all categories in the current snapshot into the image."
	
	self sourceCode snapshot ifNil: [^ self].
	
	PSReplicateSystemEvents
		value: false
		during: [
			self sourceCode snapshot keysAndValuesDo: [:category :source | | strm |
				(ReadStream on: source) fileIn]].! !

!PSSourceCodeClient methodsFor: 'as yet unclassified' stamp: 'mt 9/25/2010 12:48:03.28'!
loadSourceCode
	"Read the complete snapshot and all updates."
	
	PSReplicateSystemEvents
		value: false "Do it silently."
		during: [
			self fileInSnapshot.
			[self sourceCode updates do: [:update | self executeUpdateSilently: update]]
				on: Error do: [Transcript cr; show: 'Updates could not be loaded!! ', self sourceCode uuid asString]].! !

!PSSourceCodeClient methodsFor: 'as yet unclassified' stamp: 'mt 9/12/2010 13:26:41.406'!
log: aMessage

	Transcript cr; show: '[PS] ', aMessage.! !

!PSSourceCodeClient methodsFor: 'update handling' stamp: 'mt 9/8/2010 09:11:57.091'!
sourceCode

	self subclassResponsibility.! !

!PSSourceCodeClient methodsFor: 'snapshot handling' stamp: 'mt 9/19/2010 21:33:46.665'!
updateSnapshot
	"Extract the source code of all registered categories into a dictionary."
	
	| updatedSnapshot |
	updatedSnapshot := Dictionary new.
	
	self sourceCode packages do: [:pkg |
		(PackageInfo named: pkg) systemCategories do: [:cat | | strm |
			strm := WriteStream on: (String new: 100).
			SystemOrganization fileOutCategory: cat on: strm.
			updatedSnapshot at: cat put: strm contents]].
	
	self sourceCode disconnectSignal: #snapshotChanged: from: self.
	self sourceCode snapshot: updatedSnapshot.
	self connect: self sourceCode signal: #snapshotChanged: toSelector: #fileInSnapshot.
	
	self sourceCode addChatNotification: (PSChatNotification event: 'Snapshot updated.').! !

Object subclass: #PSSqSyncConnectionMock
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSSqSyncConnectionMock commentStamp: 'mt 9/14/2010 17:21:30.897' prior: 0!
I am a mock for an SyClient instance which is a connection to the server.!

!PSSqSyncConnectionMock methodsFor: 'connection handling' stamp: 'mt 9/14/2010 17:35:25.146'!
disconnect

	"Do nothing."! !

!PSSqSyncConnectionMock methodsFor: 'connection handling' stamp: 'mt 9/14/2010 17:46:44.478'!
flushCommands! !

!PSSqSyncConnectionMock methodsFor: 'accessing' stamp: 'mt 9/14/2010 17:46:32.452'!
isConnected
	"Always connected."
	
	^ true! !

!PSSqSyncConnectionMock methodsFor: 'accessing' stamp: 'mt 9/14/2010 17:32:49.237'!
repository

	^ repository ifNil: [repository := PSSqSyncRepositoryMock new]! !

!PSSqSyncConnectionMock methodsFor: 'accessing' stamp: 'mt 9/14/2010 20:06:17.544'!
repository: aRepository

	repository := aRepository.! !

Object subclass: #PSSqSyncRepositoryMock
	instanceVariableNames: 'rootObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSSqSyncRepositoryMock methodsFor: 'accessing' stamp: 'mt 9/14/2010 17:23:46.415'!
rootObject

	^ rootObject ifNil: [rootObject := PSSourceCodeRepository new]! !

TheWorldMainDockingBar subclass: #PSRemoteWorldMainDockingBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Morphic'!

PSRemoteWorldMainDockingBar class
	instanceVariableNames: 'instance'!

PSRemoteWorldMainDockingBar class
	instanceVariableNames: 'instance'!

!PSRemoteWorldMainDockingBar class methodsFor: 'instance creation' stamp: 'mt 10/3/2010 11:37:49.855'!
instance

	^ instance ifNil: [instance := self basicNew initialize]! !

!PSRemoteWorldMainDockingBar methodsFor: 'submenu - shared packages' stamp: 'mt 10/3/2010 12:22:44.537'!
allSharedPackagesMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'All Shared Packages';
			help: 'Browse all shared packages.';
			icon: UiSilkIcons folderExploreIcon;
			target: self;
			selector: #browseAllPackages ]! !

!PSRemoteWorldMainDockingBar methodsFor: 'submenu - polysource' stamp: 'mt 10/3/2010 11:46:33.334'!
backToLocalProjectMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Back to Local Project' translated;
			help: 'Leave this remote project and return to the local project' translated;
			icon: UiSilkIcons doorInIcon;
			target: World;
			selector: #goBack ]! !

!PSRemoteWorldMainDockingBar methodsFor: 'actions' stamp: 'mt 10/3/2010 12:22:31.884'!
browseAllPackages

	| env |
	env := (PackageEnvironment
		onEnvironment: BrowserEnvironment new
		packages: (PSCurrentRemoteClient value sourceCode packages collect: [:packageName |
			PackageInfo named: packageName]))
		label: 'All Shared Packages'.
	env browserInstance open.! !

!PSRemoteWorldMainDockingBar methodsFor: 'actions' stamp: 'mt 10/3/2010 12:22:03.136'!
browsePackage: aPackageName

	| env |
	env := (PackageEnvironment
		onEnvironment: BrowserEnvironment new
		packages: {PackageInfo named: aPackageName})
		label: aPackageName.
	env browserInstance open.! !

!PSRemoteWorldMainDockingBar methodsFor: 'submenu - polysource' stamp: 'mt 10/3/2010 11:44:03.491'!
chatMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Open chat room for ', PSCurrentRemoteClient value sourceCode author;
			help: 'Open a chat dialog to communicate to the developer.' translated;
			icon: UiSilkIcons commentsIcon;
			target: PSChatDialog;
			selector: #open ]! !

!PSRemoteWorldMainDockingBar methodsFor: 'submenu - polysource' stamp: 'mt 10/3/2010 12:26:11.915'!
debugMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Explore Remote Client';
			target: [PSCurrentRemoteClient value explore];
			selector: #value ]! !

!PSRemoteWorldMainDockingBar methodsFor: 'construction' stamp: 'mt 10/3/2010 12:17:35.252'!
menusOn: aDockingBar 

	self 
		polysourceMenuOn: aDockingBar;
		packagesMenuOn: aDockingBar;
		toolsMenuOn: aDockingBar;
		extrasMenuOn: aDockingBar;
		windowsMenuOn: aDockingBar;
		helpMenuOn: aDockingBar.
	aDockingBar addSpacer.
	self
		searchBarOn: aDockingBar;
		clockOn: aDockingBar! !

!PSRemoteWorldMainDockingBar methodsFor: 'construction' stamp: 'mt 10/3/2010 12:15:42.716'!
packagesMenuOn: aDockingBar

	aDockingBar addItem: [ :item |
		item
			contents: 'Packages';
			icon: UiSilkIcons packageIcon;
			addSubMenu: [ :menu | 
				self allSharedPackagesMenuItemOn: menu.
				menu addLine.
				
				PSCurrentRemoteClient value sourceCode packages do: [:packageName |
					self sharedPackageMenuItemOn: menu for: packageName].

				menu addLine.
				menu addItem:[:i|
					i
						contents: 'Refresh' translated;
						help: 'Update the list of shared packages.';
						icon: UiSilkIcons arrowRefreshSmallIcon;
						target: TheWorldMainDockingBar;
						selector: #updateInstances] ] ]
! !

!PSRemoteWorldMainDockingBar methodsFor: 'construction' stamp: 'mt 10/3/2010 12:26:26.301'!
polysourceMenuOn: aDockingBar

	aDockingBar addItem: [ :item |
		item
			contents: PSCurrentRemoteClient value sourceCode author;
			icon: UiSilkIcons userIcon;
			addSubMenu: [ :menu | 
				self
					chatMenuItemOn: menu;
					debugMenuItemOn: menu;
					toggleFullScreenMenuItemOn: menu.
				menu addLine.
				self backToLocalProjectMenuItemOn: menu. ] ]
! !

!PSRemoteWorldMainDockingBar methodsFor: 'submenu - shared packages' stamp: 'mt 10/3/2010 12:10:48.466'!
sharedPackageMenuItemOn: menu for: aPackageName

	menu addItem: [ :item |
		item
			contents: 'Browse "', aPackageName, '"';
			help: 'Open a package browser.';
			target: self;
			selector: #browsePackage:;
			arguments: {aPackageName} ]! !

!PSRemoteWorldMainDockingBar methodsFor: 'construction' stamp: 'mt 10/3/2010 11:53:09.858'!
toolsMenuOn: aDockingBar 

	aDockingBar addItem: [ :item |
		item
			contents: 'Tools' translated;
			addSubMenu: [ :menu | 
				self
					browserMenuItemOn: menu;
					workspaceMenuItemOn: menu;
					transcriptMenuItemOn: menu;
					testRunnerMenuItemOn: menu.
				menu addLine.
				self
					processBrowserMenuItemOn: menu. ] ]! !

!SystemOrganizer methodsFor: '*polysource-core' stamp: 'mt 8/30/2010 11:30:34.255'!
isProxy

	^ false! !

UserInterface subclass: #PSControlPanelUi
	instanceVariableNames: 'morphy1 serverContainer serverLabel morphy2 hostNameEdit portEdit morphy3 morphy4 connectButton remoteContainer remoteLabel remoteList morphy5 morphy6 openProjectButton localContainer localLabel morphy7 categoryList morphy8 morphy9 addCategoryButton removeCategoryButton uuidLabel morphy10 resetButton morphy11 updateButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-ControlPanel'!

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.952'!
addCategoryButton
	"No description given."
	
	^ addCategoryButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.802'!
categoryList
	"No description given."
	
	^ categoryList! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.258'!
connectButton
	"No description given."
	
	^ connectButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.051'!
hostNameEdit
	"No description given."
	
	^ hostNameEdit! !

!PSControlPanelUi methodsFor: 'ui - private' stamp: 'mt 9/10/2010 11:40:59.34'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: 426@540.
	panel position: 776@367.
	panel hResizing: #spaceFill.
	panel vResizing: #spaceFill.
	panel cellInset: 10.
	panel cellPositioning: #center.
	panel cellSpacing: #none.
	panel layoutInset: 0.
	panel listCentering: #topLeft.
	panel listDirection: #leftToRight.
	panel listSpacing: #none.
	panel maxCellSize: 1073741823.
	panel minCellSize: 0.
	panel wrapCentering: #topLeft.
	panel wrapDirection: #none.
	panel setProperty: #objectName toValue: 'panel'.
	panel setProperty: #objectDescription toValue: ''.
	morphy1 := UiContainer new.
	morphy1 changeTableLayout.
	morphy1 extent: 164@540.
	morphy1 position: 776@367.
	morphy1 hResizing: #spaceFill.
	morphy1 vResizing: #spaceFill.
	morphy1 cellInset: 10.
	morphy1 cellPositioning: #center.
	morphy1 cellSpacing: #none.
	morphy1 layoutInset: 0.
	morphy1 listCentering: #topLeft.
	morphy1 listDirection: #topToBottom.
	morphy1 listSpacing: #none.
	morphy1 maxCellSize: 1073741823.
	morphy1 minCellSize: 0.
	morphy1 wrapCentering: #topLeft.
	morphy1 wrapDirection: #none.
	morphy1 setProperty: #objectName toValue: 'morphy1'.
	morphy1 setProperty: #objectDescription toValue: 'No description given.'.
	serverContainer := UiContainer new.
	serverContainer changeTableLayout.
	serverContainer extent: 164@92.
	serverContainer position: 776@366.
	serverContainer hResizing: #spaceFill.
	serverContainer vResizing: #shrinkWrap.
	serverContainer cellInset: 5.
	serverContainer cellPositioning: #topLeft.
	serverContainer cellSpacing: #none.
	serverContainer layoutInset: 5.
	serverContainer listCentering: #topLeft.
	serverContainer listDirection: #topToBottom.
	serverContainer listSpacing: #none.
	serverContainer maxCellSize: 1073741823.
	serverContainer minCellSize: 0.
	serverContainer wrapCentering: #topLeft.
	serverContainer wrapDirection: #none.
	serverContainer setProperty: #objectName toValue: 'serverContainer'.
	serverContainer setProperty: #objectDescription toValue: 'No description given.'.
	serverLabel := UiLabel new.
	serverLabel changeTableLayout.
	serverLabel extent: 41@18.
	serverLabel position: 781@371.
	serverLabel hResizing: #shrinkWrap.
	serverLabel vResizing: #shrinkWrap.
	serverLabel cellInset: 0.
	serverLabel cellPositioning: #center.
	serverLabel cellSpacing: #none.
	serverLabel layoutInset: 0.
	serverLabel listCentering: #topLeft.
	serverLabel listDirection: #leftToRight.
	serverLabel listSpacing: #none.
	serverLabel maxCellSize: 1073741823.
	serverLabel minCellSize: 0.
	serverLabel wrapCentering: #topLeft.
	serverLabel wrapDirection: #none.
	serverLabel text: 'Server'.
	serverLabel setProperty: #objectName toValue: 'serverLabel'.
	serverLabel setProperty: #objectDescription toValue: 'No description given.'.
	serverContainer addMorphBack: serverLabel.
	morphy2 := UiContainer new.
	morphy2 changeTableLayout.
	morphy2 extent: 154@22.
	morphy2 position: 781@394.
	morphy2 hResizing: #spaceFill.
	morphy2 vResizing: #shrinkWrap.
	morphy2 cellInset: 4.
	morphy2 cellPositioning: #center.
	morphy2 cellSpacing: #none.
	morphy2 layoutInset: 0.
	morphy2 listCentering: #topLeft.
	morphy2 listDirection: #leftToRight.
	morphy2 listSpacing: #none.
	morphy2 maxCellSize: 1073741823.
	morphy2 minCellSize: 0.
	morphy2 wrapCentering: #topLeft.
	morphy2 wrapDirection: #none.
	morphy2 setProperty: #objectName toValue: 'morphy2'.
	morphy2 setProperty: #objectDescription toValue: 'No description given.'.
	hostNameEdit := UiLineEdit new.
	hostNameEdit extent: 78@20.
	hostNameEdit position: 781@395.
	hostNameEdit hResizing: #spaceFill.
	hostNameEdit vResizing: #rigid.
	hostNameEdit cellInset: 0.
	hostNameEdit cellPositioning: #center.
	hostNameEdit cellSpacing: #none.
	hostNameEdit layoutInset: 0.
	hostNameEdit listCentering: #topLeft.
	hostNameEdit listDirection: #topToBottom.
	hostNameEdit listSpacing: #none.
	hostNameEdit maxCellSize: 1073741823.
	hostNameEdit minCellSize: 0.
	hostNameEdit wrapCentering: #topLeft.
	hostNameEdit wrapDirection: #none.
	hostNameEdit setProperty: #objectName toValue: 'hostNameEdit'.
	hostNameEdit setProperty: #objectDescription toValue: 'No description given.'.
	morphy2 addMorphBack: hostNameEdit.
	portEdit := UiLineEdit new.
	portEdit extent: 70@20.
	portEdit position: 863@394.
	portEdit hResizing: #rigid.
	portEdit vResizing: #rigid.
	portEdit cellInset: 0.
	portEdit cellPositioning: #center.
	portEdit cellSpacing: #none.
	portEdit layoutInset: 0.
	portEdit listCentering: #topLeft.
	portEdit listDirection: #topToBottom.
	portEdit listSpacing: #none.
	portEdit maxCellSize: 1073741823.
	portEdit minCellSize: 0.
	portEdit wrapCentering: #topLeft.
	portEdit wrapDirection: #none.
	portEdit setProperty: #objectName toValue: 'portEdit'.
	portEdit setProperty: #objectDescription toValue: 'No description given.'.
	morphy2 addMorphBack: portEdit.
	serverContainer addMorphBack: morphy2.
	morphy3 := UiContainer new.
	morphy3 changeTableLayout.
	morphy3 extent: 154@29.
	morphy3 position: 781@421.
	morphy3 hResizing: #spaceFill.
	morphy3 vResizing: #shrinkWrap.
	morphy3 cellInset: 4.
	morphy3 cellPositioning: #center.
	morphy3 cellSpacing: #none.
	morphy3 layoutInset: 0.
	morphy3 listCentering: #topLeft.
	morphy3 listDirection: #leftToRight.
	morphy3 listSpacing: #none.
	morphy3 maxCellSize: 1073741823.
	morphy3 minCellSize: 0.
	morphy3 wrapCentering: #topLeft.
	morphy3 wrapDirection: #none.
	morphy3 setProperty: #objectName toValue: 'morphy3'.
	morphy3 setProperty: #objectDescription toValue: 'No description given.'.
	morphy4 := UiContainer new.
	morphy4 extent: 67@10.
	morphy4 position: 781@431.
	morphy4 hResizing: #spaceFill.
	morphy4 vResizing: #rigid.
	morphy4 cellInset: 4.
	morphy4 cellPositioning: #center.
	morphy4 cellSpacing: #none.
	morphy4 layoutInset: 4.
	morphy4 listCentering: #topLeft.
	morphy4 listDirection: #topToBottom.
	morphy4 listSpacing: #none.
	morphy4 maxCellSize: 1073741823.
	morphy4 minCellSize: 0.
	morphy4 wrapCentering: #topLeft.
	morphy4 wrapDirection: #none.
	morphy4 setProperty: #objectName toValue: 'morphy4'.
	morphy4 setProperty: #objectDescription toValue: 'No description given.'.
	morphy3 addMorphBack: morphy4.
	connectButton := UiPushButton new.
	connectButton changeTableLayout.
	connectButton extent: 81@28.
	connectButton position: 852@421.
	connectButton hResizing: #shrinkWrap.
	connectButton vResizing: #shrinkWrap.
	connectButton cellInset: 4.
	connectButton cellPositioning: #center.
	connectButton cellSpacing: #none.
	connectButton layoutInset: 4.
	connectButton listCentering: #topLeft.
	connectButton listDirection: #leftToRight.
	connectButton listSpacing: #none.
	connectButton maxCellSize: 1073741823.
	connectButton minCellSize: 0.
	connectButton wrapCentering: #topLeft.
	connectButton wrapDirection: #none.
	connectButton text: 'Connect'.
	connectButton setProperty: #objectName toValue: 'connectButton'.
	connectButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy3 addMorphBack: connectButton.
	serverContainer addMorphBack: morphy3.
	morphy1 addMorphBack: serverContainer.
	remoteContainer := UiContainer new.
	remoteContainer changeTableLayout.
	remoteContainer extent: 164@440.
	remoteContainer position: 776@467.
	remoteContainer hResizing: #spaceFill.
	remoteContainer vResizing: #spaceFill.
	remoteContainer cellInset: 4.
	remoteContainer cellPositioning: #topLeft.
	remoteContainer cellSpacing: #none.
	remoteContainer layoutInset: 4.
	remoteContainer listCentering: #topLeft.
	remoteContainer listDirection: #topToBottom.
	remoteContainer listSpacing: #none.
	remoteContainer maxCellSize: 1073741823.
	remoteContainer minCellSize: 0.
	remoteContainer wrapCentering: #topLeft.
	remoteContainer wrapDirection: #none.
	remoteContainer setProperty: #objectName toValue: 'remoteContainer'.
	remoteContainer setProperty: #objectDescription toValue: 'No description given.'.
	remoteLabel := UiLabel new.
	remoteLabel changeTableLayout.
	remoteLabel extent: 138@18.
	remoteLabel position: 780@471.
	remoteLabel hResizing: #shrinkWrap.
	remoteLabel vResizing: #shrinkWrap.
	remoteLabel cellInset: 0.
	remoteLabel cellPositioning: #center.
	remoteLabel cellSpacing: #none.
	remoteLabel layoutInset: 0.
	remoteLabel listCentering: #topLeft.
	remoteLabel listDirection: #leftToRight.
	remoteLabel listSpacing: #none.
	remoteLabel maxCellSize: 1073741823.
	remoteLabel minCellSize: 0.
	remoteLabel wrapCentering: #topLeft.
	remoteLabel wrapDirection: #none.
	remoteLabel text: 'Remote Source Codes'.
	remoteLabel setProperty: #objectName toValue: 'remoteLabel'.
	remoteLabel setProperty: #objectDescription toValue: 'No description given.'.
	remoteContainer addMorphBack: remoteLabel.
	remoteList := UiListWidget new.
	remoteList extent: 156@376.
	remoteList position: 780@493.
	remoteList hResizing: #spaceFill.
	remoteList vResizing: #spaceFill.
	remoteList cellInset: 0.
	remoteList cellPositioning: #center.
	remoteList cellSpacing: #none.
	remoteList layoutInset: 0.
	remoteList listCentering: #topLeft.
	remoteList listDirection: #topToBottom.
	remoteList listSpacing: #none.
	remoteList maxCellSize: 1073741823.
	remoteList minCellSize: 0.
	remoteList wrapCentering: #topLeft.
	remoteList wrapDirection: #none.
	remoteList setProperty: #objectName toValue: 'remoteList'.
	remoteList setProperty: #objectDescription toValue: 'No description given.'.
	remoteContainer addMorphBack: remoteList.
	morphy5 := UiContainer new.
	morphy5 changeTableLayout.
	morphy5 extent: 156@29.
	morphy5 position: 780@873.
	morphy5 hResizing: #spaceFill.
	morphy5 vResizing: #shrinkWrap.
	morphy5 cellInset: 4.
	morphy5 cellPositioning: #center.
	morphy5 cellSpacing: #none.
	morphy5 layoutInset: 0.
	morphy5 listCentering: #topLeft.
	morphy5 listDirection: #leftToRight.
	morphy5 listSpacing: #none.
	morphy5 maxCellSize: 1073741823.
	morphy5 minCellSize: 0.
	morphy5 wrapCentering: #topLeft.
	morphy5 wrapDirection: #none.
	morphy5 setProperty: #objectName toValue: 'morphy5'.
	morphy5 setProperty: #objectDescription toValue: 'No description given.'.
	morphy6 := UiContainer new.
	morphy6 extent: 39@10.
	morphy6 position: 780@883.
	morphy6 hResizing: #spaceFill.
	morphy6 vResizing: #rigid.
	morphy6 cellInset: 4.
	morphy6 cellPositioning: #center.
	morphy6 cellSpacing: #none.
	morphy6 layoutInset: 4.
	morphy6 listCentering: #topLeft.
	morphy6 listDirection: #topToBottom.
	morphy6 listSpacing: #none.
	morphy6 maxCellSize: 1073741823.
	morphy6 minCellSize: 0.
	morphy6 wrapCentering: #topLeft.
	morphy6 wrapDirection: #none.
	morphy6 setProperty: #objectName toValue: 'morphy6'.
	morphy6 setProperty: #objectDescription toValue: 'No description given.'.
	morphy5 addMorphBack: morphy6.
	openProjectButton := UiPushButton new.
	openProjectButton changeTableLayout.
	openProjectButton extent: 111@28.
	openProjectButton position: 823@873.
	openProjectButton hResizing: #shrinkWrap.
	openProjectButton vResizing: #shrinkWrap.
	openProjectButton cellInset: 4.
	openProjectButton cellPositioning: #center.
	openProjectButton cellSpacing: #none.
	openProjectButton layoutInset: 4.
	openProjectButton listCentering: #topLeft.
	openProjectButton listDirection: #leftToRight.
	openProjectButton listSpacing: #none.
	openProjectButton maxCellSize: 1073741823.
	openProjectButton minCellSize: 0.
	openProjectButton wrapCentering: #topLeft.
	openProjectButton wrapDirection: #none.
	openProjectButton text: 'Open Project'.
	openProjectButton setProperty: #objectName toValue: 'openProjectButton'.
	openProjectButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy5 addMorphBack: openProjectButton.
	remoteContainer addMorphBack: morphy5.
	morphy1 addMorphBack: remoteContainer.
	panel addMorphBack: morphy1.
	localContainer := UiContainer new.
	localContainer changeTableLayout.
	localContainer extent: 252@540.
	localContainer position: 950@367.
	localContainer hResizing: #spaceFill.
	localContainer vResizing: #spaceFill.
	localContainer cellInset: 5.
	localContainer cellPositioning: #topLeft.
	localContainer cellSpacing: #none.
	localContainer layoutInset: 5.
	localContainer listCentering: #topLeft.
	localContainer listDirection: #topToBottom.
	localContainer listSpacing: #none.
	localContainer maxCellSize: 1073741823.
	localContainer minCellSize: 0.
	localContainer wrapCentering: #topLeft.
	localContainer wrapDirection: #none.
	localContainer setProperty: #objectName toValue: 'localContainer'.
	localContainer setProperty: #objectDescription toValue: 'No description given.'.
	localLabel := UiLabel new.
	localLabel changeTableLayout.
	localLabel extent: 101@18.
	localLabel position: 955@372.
	localLabel hResizing: #shrinkWrap.
	localLabel vResizing: #shrinkWrap.
	localLabel cellInset: 0.
	localLabel cellPositioning: #center.
	localLabel cellSpacing: #none.
	localLabel layoutInset: 0.
	localLabel listCentering: #topLeft.
	localLabel listDirection: #leftToRight.
	localLabel listSpacing: #none.
	localLabel maxCellSize: 1073741823.
	localLabel minCellSize: 0.
	localLabel wrapCentering: #topLeft.
	localLabel wrapDirection: #none.
	localLabel text: 'My Source Code'.
	localLabel setProperty: #objectName toValue: 'localLabel'.
	localLabel setProperty: #objectDescription toValue: 'No description given.'.
	localContainer addMorphBack: localLabel.
	morphy7 := UiContainer new.
	morphy7 changeTableLayout.
	morphy7 extent: 242@447.
	morphy7 position: 955@395.
	morphy7 hResizing: #spaceFill.
	morphy7 vResizing: #spaceFill.
	morphy7 cellInset: 0.
	morphy7 cellPositioning: #center.
	morphy7 cellSpacing: #none.
	morphy7 layoutInset: 0.
	morphy7 listCentering: #topLeft.
	morphy7 listDirection: #leftToRight.
	morphy7 listSpacing: #none.
	morphy7 maxCellSize: 1073741823.
	morphy7 minCellSize: 0.
	morphy7 wrapCentering: #topLeft.
	morphy7 wrapDirection: #none.
	morphy7 setProperty: #objectName toValue: 'morphy7'.
	morphy7 setProperty: #objectDescription toValue: 'No description given.'.
	categoryList := UiListWidget new.
	categoryList extent: 203@447.
	categoryList position: 955@395.
	categoryList hResizing: #spaceFill.
	categoryList vResizing: #spaceFill.
	categoryList cellInset: 0.
	categoryList cellPositioning: #center.
	categoryList cellSpacing: #none.
	categoryList layoutInset: 0.
	categoryList listCentering: #topLeft.
	categoryList listDirection: #topToBottom.
	categoryList listSpacing: #none.
	categoryList maxCellSize: 1073741823.
	categoryList minCellSize: 0.
	categoryList wrapCentering: #topLeft.
	categoryList wrapDirection: #none.
	categoryList setProperty: #objectName toValue: 'categoryList'.
	categoryList setProperty: #objectDescription toValue: 'No description given.'.
	morphy7 addMorphBack: categoryList.
	morphy8 := UiContainer new.
	morphy8 changeTableLayout.
	morphy8 extent: 39@447.
	morphy8 position: 1158@395.
	morphy8 hResizing: #shrinkWrap.
	morphy8 vResizing: #spaceFill.
	morphy8 cellInset: 0.
	morphy8 cellPositioning: #center.
	morphy8 cellSpacing: #none.
	morphy8 layoutInset: 0.
	morphy8 listCentering: #topLeft.
	morphy8 listDirection: #topToBottom.
	morphy8 listSpacing: #none.
	morphy8 maxCellSize: 1073741823.
	morphy8 minCellSize: 0.
	morphy8 wrapCentering: #topLeft.
	morphy8 wrapDirection: #none.
	morphy8 setProperty: #objectName toValue: 'morphy8'.
	morphy8 setProperty: #objectDescription toValue: 'No description given.'.
	morphy9 := UiContainer new.
	morphy9 extent: 10@391.
	morphy9 position: 1172@395.
	morphy9 hResizing: #rigid.
	morphy9 vResizing: #spaceFill.
	morphy9 cellInset: 4.
	morphy9 cellPositioning: #center.
	morphy9 cellSpacing: #none.
	morphy9 layoutInset: 4.
	morphy9 listCentering: #topLeft.
	morphy9 listDirection: #topToBottom.
	morphy9 listSpacing: #none.
	morphy9 maxCellSize: 1073741823.
	morphy9 minCellSize: 0.
	morphy9 wrapCentering: #topLeft.
	morphy9 wrapDirection: #none.
	morphy9 setProperty: #objectName toValue: 'morphy9'.
	morphy9 setProperty: #objectDescription toValue: 'No description given.'.
	morphy8 addMorphBack: morphy9.
	addCategoryButton := UiToolButton new.
	addCategoryButton changeTableLayout.
	addCategoryButton extent: 39@28.
	addCategoryButton position: 1158@786.
	addCategoryButton hResizing: #shrinkWrap.
	addCategoryButton vResizing: #shrinkWrap.
	addCategoryButton cellInset: 4.
	addCategoryButton cellPositioning: #center.
	addCategoryButton cellSpacing: #none.
	addCategoryButton layoutInset: 4.
	addCategoryButton listCentering: #topLeft.
	addCategoryButton listDirection: #leftToRight.
	addCategoryButton listSpacing: #none.
	addCategoryButton maxCellSize: 1073741823.
	addCategoryButton minCellSize: 0.
	addCategoryButton wrapCentering: #topLeft.
	addCategoryButton wrapDirection: #none.
	addCategoryButton text: '+'.
	addCategoryButton setProperty: #objectName toValue: 'addCategoryButton'.
	addCategoryButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy8 addMorphBack: addCategoryButton.
	removeCategoryButton := UiToolButton new.
	removeCategoryButton changeTableLayout.
	removeCategoryButton extent: 39@28.
	removeCategoryButton position: 1158@814.
	removeCategoryButton hResizing: #shrinkWrap.
	removeCategoryButton vResizing: #shrinkWrap.
	removeCategoryButton cellInset: 4.
	removeCategoryButton cellPositioning: #center.
	removeCategoryButton cellSpacing: #none.
	removeCategoryButton layoutInset: 4.
	removeCategoryButton listCentering: #topLeft.
	removeCategoryButton listDirection: #leftToRight.
	removeCategoryButton listSpacing: #none.
	removeCategoryButton maxCellSize: 1073741823.
	removeCategoryButton minCellSize: 0.
	removeCategoryButton wrapCentering: #topLeft.
	removeCategoryButton wrapDirection: #none.
	removeCategoryButton text: '-'.
	removeCategoryButton setProperty: #objectName toValue: 'removeCategoryButton'.
	removeCategoryButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy8 addMorphBack: removeCategoryButton.
	morphy7 addMorphBack: morphy8.
	localContainer addMorphBack: morphy7.
	uuidLabel := UiLabel new.
	uuidLabel changeTableLayout.
	uuidLabel extent: 38@18.
	uuidLabel position: 955@847.
	uuidLabel hResizing: #shrinkWrap.
	uuidLabel vResizing: #shrinkWrap.
	uuidLabel cellInset: 0.
	uuidLabel cellPositioning: #center.
	uuidLabel cellSpacing: #none.
	uuidLabel layoutInset: 0.
	uuidLabel listCentering: #topLeft.
	uuidLabel listDirection: #leftToRight.
	uuidLabel listSpacing: #none.
	uuidLabel maxCellSize: 1073741823.
	uuidLabel minCellSize: 0.
	uuidLabel wrapCentering: #topLeft.
	uuidLabel wrapDirection: #none.
	uuidLabel text: '(UUID)'.
	uuidLabel setProperty: #objectName toValue: 'uuidLabel'.
	uuidLabel setProperty: #objectDescription toValue: 'No description given.'.
	localContainer addMorphBack: uuidLabel.
	morphy10 := UiContainer new.
	morphy10 changeTableLayout.
	morphy10 extent: 242@31.
	morphy10 position: 955@870.
	morphy10 hResizing: #spaceFill.
	morphy10 vResizing: #shrinkWrap.
	morphy10 cellInset: 4.
	morphy10 cellPositioning: #center.
	morphy10 cellSpacing: #none.
	morphy10 layoutInset: 0.
	morphy10 listCentering: #topLeft.
	morphy10 listDirection: #leftToRight.
	morphy10 listSpacing: #none.
	morphy10 maxCellSize: 1073741823.
	morphy10 minCellSize: 0.
	morphy10 wrapCentering: #topLeft.
	morphy10 wrapDirection: #none.
	morphy10 setProperty: #objectName toValue: 'morphy10'.
	morphy10 setProperty: #objectDescription toValue: 'No description given.'.
	resetButton := UiPushButton new.
	resetButton changeTableLayout.
	resetButton extent: 65@28.
	resetButton position: 956@872.
	resetButton hResizing: #shrinkWrap.
	resetButton vResizing: #shrinkWrap.
	resetButton cellInset: 4.
	resetButton cellPositioning: #center.
	resetButton cellSpacing: #none.
	resetButton layoutInset: 4.
	resetButton listCentering: #topLeft.
	resetButton listDirection: #leftToRight.
	resetButton listSpacing: #none.
	resetButton maxCellSize: 1073741823.
	resetButton minCellSize: 0.
	resetButton wrapCentering: #topLeft.
	resetButton wrapDirection: #none.
	resetButton text: 'Reset'.
	resetButton setProperty: #objectName toValue: 'resetButton'.
	resetButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy10 addMorphBack: resetButton.
	morphy11 := UiContainer new.
	morphy11 extent: 27@10.
	morphy11 position: 1026@881.
	morphy11 hResizing: #spaceFill.
	morphy11 vResizing: #rigid.
	morphy11 cellInset: 4.
	morphy11 cellPositioning: #center.
	morphy11 cellSpacing: #none.
	morphy11 layoutInset: 4.
	morphy11 listCentering: #topLeft.
	morphy11 listDirection: #topToBottom.
	morphy11 listSpacing: #none.
	morphy11 maxCellSize: 1073741823.
	morphy11 minCellSize: 0.
	morphy11 wrapCentering: #topLeft.
	morphy11 wrapDirection: #none.
	morphy11 setProperty: #objectName toValue: 'morphy11'.
	morphy11 setProperty: #objectDescription toValue: 'No description given.'.
	morphy10 addMorphBack: morphy11.
	updateButton := UiPushButton new.
	updateButton changeTableLayout.
	updateButton extent: 138@30.
	updateButton position: 1057@870.
	updateButton hResizing: #shrinkWrap.
	updateButton vResizing: #shrinkWrap.
	updateButton cellInset: 4.
	updateButton cellPositioning: #center.
	updateButton cellSpacing: #none.
	updateButton layoutInset: 4.
	updateButton listCentering: #topLeft.
	updateButton listDirection: #leftToRight.
	updateButton listSpacing: #none.
	updateButton maxCellSize: 1073741823.
	updateButton minCellSize: 0.
	updateButton wrapCentering: #topLeft.
	updateButton wrapDirection: #none.
	updateButton text: 'Update Snapshot'.
	updateButton setProperty: #objectName toValue: 'updateButton'.
	updateButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy10 addMorphBack: updateButton.
	localContainer addMorphBack: morphy10.
	panel addMorphBack: localContainer.
	panel setProperty: #uiClassName toValue: 'PSControlPanel'.! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.655'!
localContainer
	"No description given."
	
	^ localContainer! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.708'!
localLabel
	"No description given."
	
	^ localLabel! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:57.833'!
morphy1
	"No description given."
	
	^ morphy1! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.088'!
morphy10
	"No description given."
	
	^ morphy10! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.19'!
morphy11
	"No description given."
	
	^ morphy11! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.002'!
morphy2
	"No description given."
	
	^ morphy2! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.169'!
morphy3
	"No description given."
	
	^ morphy3! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.218'!
morphy4
	"No description given."
	
	^ morphy4! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.507'!
morphy5
	"No description given."
	
	^ morphy5! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.544'!
morphy6
	"No description given."
	
	^ morphy6! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.743'!
morphy7
	"No description given."
	
	^ morphy7! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.843'!
morphy8
	"No description given."
	
	^ morphy8! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.887'!
morphy9
	"No description given."
	
	^ morphy9! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.601'!
openProjectButton
	"No description given."
	
	^ openProjectButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.111'!
portEdit
	"No description given."
	
	^ portEdit! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.319'!
remoteContainer
	"No description given."
	
	^ remoteContainer! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.396'!
remoteLabel
	"No description given."
	
	^ remoteLabel! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.454'!
remoteList
	"No description given."
	
	^ remoteList! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.008'!
removeCategoryButton
	"No description given."
	
	^ removeCategoryButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.123'!
resetButton
	"No description given."
	
	^ resetButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:57.904'!
serverContainer
	"No description given."
	
	^ serverContainer! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:57.95'!
serverLabel
	"No description given."
	
	^ serverLabel! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.238'!
updateButton
	"No description given."
	
	^ updateButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.043'!
uuidLabel
	"No description given."
	
	^ uuidLabel! !

Morph subclass: #PSChatDialog
	instanceVariableNames: 'window chatList lineEdit clientList sendMessageButton enableHtmlChk statusCombo statusLineEdit statusLabel statusIcon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Chat'!

!PSChatDialog class methodsFor: 'as yet unclassified' stamp: 'mt 9/13/2010 13:57:32.9'!
open

	^ self new open.! !

!PSChatDialog methodsFor: 'initialization' stamp: 'mt 9/22/2010 09:58:33.857'!
addMainControls

	| splitter statusBar |
	statusBar := SwaRowPanel for: (
		PSCurrentRemoteClient value
			ifNil: [{statusCombo. statusLineEdit}]
			ifNotNil: [{statusIcon. statusLabel}]).
	
	PSCurrentRemoteClient value
		ifNil: [statusBar color: (Color white); cellInset: 5; borderStyle: (BorderStyle inset width: 1)]
		ifNotNil: [statusBar color: (Color gray: 0.95); cellInset: 5].
	
	splitter := BorderedMorph new
		color: Color transparent;
		borderWidth: 0;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		changeProportionalLayout.
		
	splitter
		addMorph: clientList
			fullFrame: (LayoutFrame fractions: (0@0 corner: 0.2@1));
		addMorph: ((SwaColumnPanel for: {
			chatList withScrollBar hResizing: #spaceFill; vResizing:#spaceFill.
			(SwaRowPanel for: {lineEdit. enableHtmlChk. sendMessageButton}) cellInset: 0.
			}) color: (Color gray: 0.95))
			fullFrame: (LayoutFrame fractions: (0.2@0 corner: 1@1));
		addPaneSplitters.
		
	self
		addMorphBack: statusBar;
		addMorphBack: splitter.! !

!PSChatDialog methodsFor: 'message adding' stamp: 'mt 9/18/2010 16:24:56.428'!
addMessage

	lineEdit acceptTextInModel.
	self addMessage: lineEdit textMorph contents.! !

!PSChatDialog methodsFor: 'message adding' stamp: 'mt 9/20/2010 12:04:36.159'!
addMessage: aText

	lineEdit theText: ''.
	
	(aText isNil
		or: [aText isEmpty]
		or: [self sourceCode isNil]) ifTrue: [^ self].
	
	self sourceCode addChatMessage: (PSChatMessage message: 
		(enableHtmlChk checked
			ifTrue: [aText asString asHtmlText]
			ifFalse: [aText])).! !

!PSChatDialog methodsFor: 'accessing' stamp: 'mt 9/13/2010 14:05:59.64'!
adoptPaneColor: paneColor

	"Ignore."! !

!PSChatDialog methodsFor: 'initialization' stamp: 'mt 9/22/2010 09:54:20.485'!
initialize

	super initialize.
	
	self
		color: (Color gray: 0.95);
		extent: 400@300;
		changeTableLayout;
		listDirection: #topToBottom;
		cellInset: 5;
		layoutInset: 2.
		
	self
		initializeUiControls;
		addMainControls;
		initializeSourceCodeConnections;
		startStepping;
		initializeStatus.
		
	self connect: PSLocalClient instance signal: #connected toSelector: #initializeSourceCodeConnections.

	self connect: PSLocalClient instance signal: #connected toSelector: #updateWindowTitle.
	self connect: PSLocalClient instance signal: #disconnected toSelector: #updateWindowTitle.
	
	self connect: PSLocalClient instance signal: #connected toSelector: #initializeStatus.
	self connect: PSLocalClient instance signal: #disconnected toSelector: #initializeStatus.! !

!PSChatDialog methodsFor: 'initialization' stamp: 'mt 9/20/2010 11:57:50.606'!
initializeSourceCodeConnections

	self sourceCode ifNil: [^ self].
	
	self sourceCode disconnectSignal: #chatMessageAdded: from: self.
	self sourceCode disconnectSignal: #chatNotificationAdded: from: self.
	
	self connect: self sourceCode signal: #chatMessageAdded: toSelector: #updateListWithMessage:.
	self connect: self sourceCode signal: #chatNotificationAdded: toSelector: #updateListWithNotification:.! !

!PSChatDialog methodsFor: 'initialization' stamp: 'mt 9/20/2010 16:24:47.943'!
initializeStatus

	self sourceCode ifNotNil: [:src |
		src needsHelp
			ifTrue: [statusCombo currentIndex: 2]
			ifFalse: [statusCombo currentIndex: 1].
			
		src chatStatus ifNotNil: [:stat |
			statusLineEdit theText: stat message]].! !

!PSChatDialog methodsFor: 'initialization' stamp: 'mt 9/22/2010 09:55:14.261'!
initializeUiControls

	chatList := PSChatListMorph new.

	lineEdit := UiLineEdit new.
	lineEdit outerBorderWidth: 0.
	lineEdit helpText: 'Type your chat message here.'.
	self connect: lineEdit signal: #returnPressed: toSelector: #addMessage:.
	
	clientList := UiListView
		on: PSChatClientListModel new
		list: #clientNames
		get: #currentClientIndex
		set: #currentClientIndex:
		icons: #statusIcons.
	clientList
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		iconBackgroundColor: Color transparent;
		color: (Color gray: 0.95);
		borderWidth: 0.
	
	sendMessageButton := UiToolButton new
		icon: UiSilkIcons commentIcon;
		text: 'Send';
		autoRaise: true;
		color: (Color gray: 0.95).
	self connect: sendMessageButton signal: #clicked: toSelector: #addMessage.
	
	enableHtmlChk := UiToolButton new
		buttonStyle: #iconOnly;
		checkable: true;
		autoRaise: true;
		icon: UiSilkIcons tagIcon;
		setBalloonText: 'Allow HTML tags, e.g. <b> for bold.';
		color: (Color gray: 0.95);
		checked: true.
		
	statusCombo := UiComboBox new
		readOnly: true;
		addIcon: UiFugueIcons tickCircleIcon text: 'I''m fine.';
		addIcon: UiFugueIcons questionIcon text: 'Help me!!';
		color: (Color gray: 0.95);
		currentIndex: 1;
		width: 110.
	self connect: statusCombo signal: #currentIndexChanged:text: toSelector: #setStatus.
		
	statusLineEdit := UiLineEdit new
		outerBorderWidth: 0;
		borderWidth: 0;
		helpText: 'Type your status message here.'.
	self connect: statusLineEdit signal: #returnPressed: toSelector: #setStatus:.
	
	statusLabel := UiLabel new text: 'I''m fine.'; hResizing: #spaceFill.
	statusIcon :=  UiLabel new form: UiFugueIcons tickCircleIcon.! !

!PSChatDialog methodsFor: 'open' stamp: 'mt 9/20/2010 16:05:49.432'!
open

	window := (self openInWindowLabeled: 'PolySource Chat')
		model: self.
	
	self updateWindowTitle.
	
	self color: (Color gray: 0.95).
	^ window! !

!PSChatDialog methodsFor: 'status setting' stamp: 'mt 9/20/2010 15:19:53.589'!
setStatus

	| helpNeeded |
	self sourceCode ifNil: [^ self].
	self sourceCode chatStatus ifNil: [^ self].
	
	helpNeeded := statusCombo currentIndex = 2.
	
	helpNeeded = self sourceCode chatStatus needsHelp ifTrue: [^ self].
	
	self sourceCode chatStatus needsHelp: helpNeeded.
	
	self sourceCode addChatNotification: (PSChatNotification event: (helpNeeded ifTrue: ['Help needed.'] ifFalse: ['No more help needed.'])).! !

!PSChatDialog methodsFor: 'status setting' stamp: 'mt 9/20/2010 15:19:59.022'!
setStatus: aStatusMessage

	self sourceCode ifNil: [^ self].
	self sourceCode chatStatus ifNil: [^ self].
	
	self sourceCode chatStatus message: aStatusMessage.
	
	self sourceCode addChatNotification: (PSChatNotification event: ('Status message changed to: <i>"', aStatusMessage asString, '"</i>.') asHtmlText).! !

!PSChatDialog methodsFor: 'accessing' stamp: 'mt 9/20/2010 11:52:49.392'!
sourceCode

	^ ((PSCurrentRemoteClient value) ifNil: [PSLocalClient instance]) sourceCode! !

!PSChatDialog methodsFor: 'stepping' stamp: 'mt 9/20/2010 16:22:00.959'!
step

	"Lightweight polling."
	clientList model checkClientNames..
	clientList model checkOnlineStatus.
	
	self sourceCode ifNotNil: [:src |
		src needsHelp
			ifTrue: [statusIcon form: UiFugueIcons questionIcon]
			ifFalse: [statusIcon form: UiFugueIcons tickCircleIcon].
			
		src chatStatus ifNotNil: [:stat |
			statusLabel text: stat message]].! !

!PSChatDialog methodsFor: 'stepping' stamp: 'mt 9/20/2010 11:52:15.565'!
stepTime

	^ 500 "ms"! !

!PSChatDialog methodsFor: 'updating' stamp: 'mt 9/20/2010 14:49:24.932'!
updateListWithMessage: aChatMessage

	chatList addMessage: (PSChatMessageMorph fromMessage: aChatMessage).! !

!PSChatDialog methodsFor: 'updating' stamp: 'mt 9/20/2010 14:50:12.4'!
updateListWithNotification: aChatNotification

	chatList addNotification: (PSChatNotificationMorph fromNotification: aChatNotification).! !

!PSChatDialog methodsFor: 'accessing' stamp: 'mt 9/20/2010 15:52:48.959'!
updateWindowTitle

	window ifNil: [^ self].
	window setLabel: 'PolySource Chat - ', (self sourceCode ifNil: ['Offline.'] ifNotNil: ['Developer: ', self sourceCode author])! !

Morph subclass: #PSChatListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Chat'!

!PSChatListMorph class methodsFor: 'defaults' stamp: 'mt 9/13/2010 09:28:38.617'!
defaultWidth

	^ 400! !

!PSChatListMorph methodsFor: 'add/remove' stamp: 'mt 9/13/2010 14:32:32.246'!
addMessage: aChatMessage
	
	(self submorphs notEmpty
		and: [self submorphs last isKindOf: PSChatMessageMorph]
		and: [self submorphs last author = aChatMessage author])
		ifTrue: [aChatMessage hideAuthor].
	
	aChatMessage width: self width.
	
	self addMorphBack: aChatMessage.

	self redraw.
	self focusChanged: aChatMessage bounds.
	
! !

!PSChatListMorph methodsFor: 'add/remove' stamp: 'mt 9/19/2010 21:49:05.462'!
addNotification: aChatNotification

	(self submorphs notEmpty
		and: [self submorphs last isKindOf: PSChatNotificationMorph])
		ifTrue: [aChatNotification drawTopLine: false].

	self addMorphBack: aChatNotification.
	
	self redraw.
	self focusChanged: aChatNotification bounds.! !

!PSChatListMorph methodsFor: 'signals' stamp: 'mt 9/13/2010 09:29:23.753'!
focusChanged: aRectangle
	"Give any receiver the chance to react to a change of an area that is important to me at this moment."

	self emitAlways.! !

!PSChatListMorph methodsFor: 'initialization' stamp: 'mt 9/18/2010 15:40:29.062'!
initialize

	super initialize.
	self
		vResizing: #shrinkWrap;
		hResizing: #rigid;
		width: self class defaultWidth;
		changeTableLayout;
		listDirection: #topToBottom;
		color: Color transparent;
		layoutInset: 5;
		cellPositioning: #topLeft.! !

!PSChatListMorph methodsFor: 'layout' stamp: 'mt 9/13/2010 09:16:44.84'!
layoutBounds: bounds

	super layoutBounds: bounds.
	self resized.! !

!PSChatListMorph methodsFor: 'signals' stamp: 'mt 9/13/2010 09:16:36.927'!
resized

	self emit.! !

!PSChatListMorph methodsFor: 'initialization' stamp: 'mt 9/13/2010 09:17:01.188'!
withScrollBar

	^ PSChatScrollPane new
		scrollTarget: self! !

Morph subclass: #PSChatMessageMorph
	instanceVariableNames: 'author message timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Chat'!

!PSChatMessageMorph class methodsFor: 'instance creation' stamp: 'mt 9/20/2010 14:49:13.367'!
fromMessage: aChatMessage

	^ self new
		author: aChatMessage author;
		message: aChatMessage message;
		timestamp: aChatMessage timestamp! !

!PSChatMessageMorph methodsFor: 'as yet unclassified' stamp: 'mt 9/13/2010 14:19:59.297'!
author

	^ author contents asString.! !

!PSChatMessageMorph methodsFor: 'as yet unclassified' stamp: 'mt 9/18/2010 15:42:37.386'!
author: aString

	author contents: 
		('<b><font size="7" color="#0000CC">', 
		aString,
		'</font></b>') asHtmlText! !

!PSChatMessageMorph methodsFor: 'as yet unclassified' stamp: 'mt 9/13/2010 12:05:12.484'!
hideAuthor

	author owner ifNil: [^ self].
	self removeMorph: author.! !

!PSChatMessageMorph methodsFor: 'as yet unclassified' stamp: 'mt 9/13/2010 13:21:21.117'!
initialize

	super initialize.
	self
"		extent: 100@100;"
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		color: Color transparent;
		changeTableLayout;
		listDirection: #topToBottom;
		cellPositioning: #topLeft.
		
	author := TextMorph new hResizing: #spaceFill; contents: '<b><font color="#0000CC">Author</font></b>' asHtmlText.
	message := TextMorph new hResizing: #spaceFill; contentsWrapped: '...'.
	timestamp := TextMorph new contents: '<font color="#AAAAAA">12:34</font>' asHtmlText.
	
	self
		showAuthor;
		addMorphBack: ((SwaRowPanel for: {message. timestamp}) cellPositioning: #topLeft).! !

!PSChatMessageMorph methodsFor: 'as yet unclassified' stamp: 'mt 9/13/2010 11:53:26.555'!
message: aText

	message contentsWrapped: aText.! !

!PSChatMessageMorph methodsFor: 'as yet unclassified' stamp: 'mt 9/13/2010 12:05:33.406'!
showAuthor

	author owner ifNotNil: [^ self].
	self addMorphFront: author.! !

!PSChatMessageMorph methodsFor: 'as yet unclassified' stamp: 'mt 9/19/2010 22:15:31.023'!
timestamp: aTimeStamp

	timestamp contents: 
		('<font color="#AAAAAA">', 
		(String streamContents: [:aStream | aTimeStamp time print24: true showSeconds: false on: aStream]),
		'</font>') asHtmlText.
	timestamp setBalloonText: aTimeStamp asString.
	
	
	
	
! !

Morph subclass: #PSChatNotificationMorph
	instanceVariableNames: 'icon message timestamp drawTopLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Chat'!

!PSChatNotificationMorph class methodsFor: 'instance creation' stamp: 'mt 9/20/2010 14:49:55.503'!
fromNotification: aChatNotification
	
 	^ self new
		icon: aChatNotification asIcon;
		message: aChatNotification asText;
		timestamp: aChatNotification timestamp! !

!PSChatNotificationMorph methodsFor: 'drawing' stamp: 'mt 9/19/2010 21:46:35.492'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self drawTopLine ifTrue: [
		aCanvas
			line: self topLeft + (0@2)
			to: self topRight + (0@2)
			color: (Color gray: 0.7)].
		
	aCanvas
		line: self bottomLeft - (0@3)
		to: self bottomRight - (0@3)
		color: (Color gray: 0.7).! !

!PSChatNotificationMorph methodsFor: 'accessing' stamp: 'mt 9/19/2010 21:45:45.539'!
drawTopLine

	^ drawTopLine ifNil: [drawTopLine := true]! !

!PSChatNotificationMorph methodsFor: 'accessing' stamp: 'mt 9/19/2010 21:47:41.732'!
drawTopLine: aBoolean

	drawTopLine = aBoolean ifTrue: [^ self].
	drawTopLine := aBoolean.
	
	self layoutInset: (0@(self drawTopLine ifTrue: [5] ifFalse: [0]) corner: 0@5).! !

!PSChatNotificationMorph methodsFor: 'accessing' stamp: 'mt 9/19/2010 21:03:06.117'!
icon: aForm

	icon form: aForm.! !

!PSChatNotificationMorph methodsFor: 'initialization' stamp: 'mt 9/13/2010 10:26:53.739'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		color: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		cellPositioning: #topLeft;
		layoutInset: (0@5 corner: 0@5);
		cellInset: 5.
		
	icon := UiLabel new form: UiSilkIcons clockIcon.
	message := TextMorph new hResizing: #spaceFill; contentsWrapped: '<b>Mig</b> changed your source code class <b>String</b>.' asHtmlText.
	timestamp := TextMorph new contents: '<font color="#AAAAAA">12:34</font>' asHtmlText.
	
	self
		addMorphBack: icon;
		addMorphBack: message;
		addMorphBack: timestamp.! !

!PSChatNotificationMorph methodsFor: 'accessing' stamp: 'mt 9/13/2010 15:05:57.932'!
message: aText

	message contentsWrapped: aText.! !

!PSChatNotificationMorph methodsFor: 'accessing' stamp: 'mt 9/19/2010 22:15:39.63'!
timestamp: aTimeStamp

	timestamp contents: 
		('<font color="#AAAAAA">', 
		(String streamContents: [:aStream | aTimeStamp time print24: true showSeconds: false on: aStream]),
		'</font>') asHtmlText.
	timestamp setBalloonText: aTimeStamp asString.
	! !

Morph subclass: #PSControlPanel
	instanceVariableNames: 'ui lastNetworkSpeed'
	classVariableNames: 'LastHostName LastPort'
	poolDictionaries: ''
	category: 'PolySource-ControlPanel'!

!PSControlPanel class methodsFor: 'as yet unclassified' stamp: 'mt 9/8/2010 10:48:54.718'!
open

	self new open.! !

!PSControlPanel methodsFor: 'actions' stamp: 'mt 9/15/2010 09:51:45.023'!
addPackage

	| result |
	result := ListChooser
		chooseItemFrom: PackageOrganizer default packageNames sorted
		title: 'Select Package'.
	
	result ifNil: [^ self].
	
	PSLocalClient instance addPackage: result.! !

!PSControlPanel methodsFor: 'updating - package list' stamp: 'mt 9/10/2010 11:31:18.196'!
addPackage: aPackageName

	self ui categoryList addText: aPackageName.! !

!PSControlPanel methodsFor: 'updating - remote list' stamp: 'mt 9/9/2010 09:53:50.389'!
addRemoteClient: aRemoteClient

	self ui remoteList addText: aRemoteClient sourceCode uuid asString.! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/8/2010 12:03:17.475'!
changeLastHostName: aText

	LastHostName := aText.! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/12/2010 12:09:26.608'!
changeLastNetworkSpeed: aFloat

	lastNetworkSpeed := aFloat.
	self updateServerInfoLabel.! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/8/2010 12:03:27.492'!
changeLastPort: aText

	LastPort := aText.! !

!PSControlPanel methodsFor: 'actions' stamp: 'mt 9/8/2010 11:12:09.606'!
connectToServer

	PSLocalClient instance connectTo: self ui hostNameEdit theText.! !

!PSControlPanel methodsFor: 'actions' stamp: 'mt 9/8/2010 11:12:19.039'!
disconnectFromServer

	PSLocalClient instance disconnect.! !

!PSControlPanel methodsFor: 'initialize' stamp: 'mt 9/12/2010 12:08:01.158'!
initialize

	super initialize.
	self ui setupUi: self.
	self postUiSetup.
	
	self
		color: (Color gray: 0.8);
		width: 500;
		height: 350.
		
	lastNetworkSpeed := 0.
		
	self
		initializeConnections;
		updateServerInfo;
		updateUuidLabel: PSLocalClient instance uuid;
		updateRemoteInfo;
		updateLocalInfo.! !

!PSControlPanel methodsFor: 'initialize' stamp: 'mt 9/18/2010 17:14:45.599'!
initializeConnections

	self connect: PSLocalClient instance signal: #connected toSelector: #updateServerInfo.
	self connect: PSLocalClient instance signal: #connected toSelector: #updateRemoteInfo.
	self connect: PSLocalClient instance signal: #connected toSelector: #updateLocalInfo.
	self connect: PSLocalClient instance signal: #disconnected toSelector: #updateServerInfo.
	self connect: PSLocalClient instance signal: #disconnected toSelector: #updateRemoteInfo.
	self connect: PSLocalClient instance signal: #disconnected toSelector: #updateLocalInfo.
	
	self connect: self ui resetButton signal: #clicked: to: PSLocalClient selector: #reset.
	self connect: self ui updateButton signal: #clicked: to: PSLocalClient instance selector: #updateSnapshot.

	self connect: self ui openProjectButton signal: #clicked: toSelector: #openRemoteProject.

	self connect: PSLocalClient instance signal: #uuidGenerated: toSelector: #updateUuidLabel:.
	
	self connect: self ui hostNameEdit signal: #textEdited: toSelector: #changeLastHostName:.
	self connect: self ui portEdit signal: #textEdited: toSelector: #changeLastPort:.
	
	"self connect: PSLocalClient instance signal: #networkTrafficChanged: toSelector: #changeLastNetworkSpeed:."! !

!PSControlPanel methodsFor: 'open' stamp: 'mt 9/9/2010 11:58:46.753'!
open

	| window |
	Smalltalk globals isProxy ifFalse: [Error signal: 'You need to install the proxy with: ''PSSystemDictionaryProxy install''.'].
	
	window := (self openInWindowLabeled: 'PolySource Control Panel')
		model: self.
		
	self color: (Color gray: 0.8).
	^ window! !

!PSControlPanel methodsFor: 'actions' stamp: 'mt 9/8/2010 12:09:00.391'!
openRemoteProject
	
	self ui remoteList currentItem ifNotNil: [:item |
		(PSLocalClient instance remoteClients
			detect: [:rc | rc sourceCode uuid asString = item text]
			ifNone: []) open].! !

!PSControlPanel methodsFor: 'initialize' stamp: 'mt 9/10/2010 11:42:44.183'!
postUiSetup

	self ui remoteList autoDeselect: false.
	self ui categoryList autoDeselect: false.
	
	self ui serverLabel text: '<b>Server</b>' asHtmlText.
"	self ui serverContainer color: (Color gray: 0.7)."
	self ui remoteLabel text: '<b>Remote Source Codes</b>' asHtmlText.
"	self ui remoteContainer color: (Color gray: 0.7)."
	self ui localLabel text: '<b>My Source Code</b>' asHtmlText.
"	self ui localContainer color: (Color gray: 0.7)."
	
	self ui connectButton icon: UiSilkIcons connectIcon.
	self ui hostNameEdit theText: (LastHostName ifNil: ['localhost']).
	(self ui portEdit)
		theText: (LastPort ifNil: ['22701']);
		validator: [:value | value asInteger min: 65536 max: 0].
		
	self ui openProjectButton icon: UiSilkIcons applicationGoIcon.
	
	self ui addCategoryButton buttonStyle: #iconOnly; icon: UiFugueIcons plusIcon; autoRaise: true.
	self ui removeCategoryButton buttonStyle: #iconOnly; icon: UiFugueIcons minusIcon; autoRaise: true.

	self ui resetButton icon: UiSilkIcons bombIcon.
	self ui updateButton icon: UiSilkIcons pageRefreshIcon.! !

!PSControlPanel methodsFor: 'initialize' stamp: 'mt 9/8/2010 10:48:39.648'!
release
	"Callback when window is closed."
! !

!PSControlPanel methodsFor: 'actions' stamp: 'mt 9/10/2010 11:19:19.585'!
removePackage

	self ui categoryList currentItem ifNotNil: [:item |
		"TODO"].! !

!PSControlPanel methodsFor: 'updating - package list' stamp: 'mt 9/10/2010 11:31:24.945'!
removePackage: aPackageName

	self updateLocalInfo.! !

!PSControlPanel methodsFor: 'updating - remote list' stamp: 'mt 9/9/2010 09:53:59.723'!
removeRemoteClient: aRemoteClient

	self updateRemoteInfo.! !

!PSControlPanel methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:41:10.627'!
ui

	^ ui ifNil: [ui := PSControlPanelUi new].! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/10/2010 11:34:00.442'!
updateLocalInfo

	self ui categoryList clear.
	self ui addCategoryButton disconnectSignal: #clicked:.
	self ui removeCategoryButton disconnectSignal: #clicked:.

	PSLocalClient instance sourceCode ifNotNil: [:src |
		src packages do: [:pkg | self ui categoryList addText: pkg].
		
		src disconnectSignal: #packageAdded: from: self.
		src disconnectSignal: #packageRemoved: from: self.
		
		self connect: src signal: #packageAdded: toSelector: #addPackage:.
		self connect: src signal: #packageRemoved: toSelector: #removePackage:.
		
		self connect: self ui addCategoryButton signal: #clicked: toSelector: #addPackage.
		self connect: self ui removeCategoryButton signal: #clicked: toSelector: #removePackage.
		].! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/9/2010 09:53:31.56'!
updateRemoteInfo

	self ui remoteList clear.

	PSLocalClient instance isConnected
		ifTrue: [
			PSLocalClient instance remoteClients do: [:rc |
				self ui remoteList addText: rc sourceCode uuid asString].

			PSLocalClient instance disconnectSignal: #remoteClientAdded: from: self.
			PSLocalClient instance disconnectSignal: #remoteClientRemoved: from: self.
			
			self connect: PSLocalClient instance signal: #remoteClientAdded: toSelector: #addRemoteClient:.
			self connect: PSLocalClient instance signal: #remoteClientRemoved: toSelector: #removeRemoteClient:].! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/12/2010 12:09:20.526'!
updateServerInfo

	self updateServerInfoLabel.
	
	PSLocalClient instance isConnected
		ifTrue: [
			self ui connectButton disconnectSignal: #clicked:.
			self ui connectButton
				icon: UiSilkIcons disconnectIcon;
				text: 'Disconnect'.
			self connect: self ui connectButton signal: #clicked: toSelector: #disconnectFromServer.
			]
		ifFalse: [
			self ui connectButton disconnectSignal: #clicked:.
			self ui connectButton
				icon: UiSilkIcons connectIcon;
				text: 'Connect'.
			self connect: self ui connectButton signal: #clicked: toSelector: #connectToServer.
			].! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/18/2010 17:14:28.304'!
updateServerInfoLabel

	PSLocalClient instance isConnected
		ifTrue: [self ui serverLabel text: '<b>Server</b> connected.' asHtmlText]
		ifFalse: [self ui serverLabel text: '<b>Server</b> disconnected.' asHtmlText]! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/8/2010 11:19:03.483'!
updateUuidLabel: aUUID

	self ui uuidLabel text: aUUID asString.! !

ProjectViewMorph subclass: #PSRemoteProjectViewMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Morphic'!

!PSRemoteProjectViewMorph methodsFor: 'events' stamp: 'mt 9/20/2010 18:06:58.377'!
enter

	PSCurrentRemoteClient 
		value: project world remoteClient
		during: [super enter].! !

!Project class methodsFor: '*polysource-core-override' stamp: 'mt 10/1/2010 10:06:00.729'!
spawnNewProcess

	UIProcess := [
		[World doOneCycle. Processor yield] repeat.
	] newProcess priority: Processor userSchedulingPriority.
	"The dynamic scope in a UI process will be set in the custom render loop in a remote world. So remote that scope for this process from the general environment."
	UIProcess environmentAt: PSCurrentRemoteClient put: nil.
	UIProcess resume.! !

DynamicVariable subclass: #PSCurrentRemoteClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSCurrentRemoteClient commentStamp: 'mig 9/8/2010 11:40:31.429' prior: 0!
I am a dynamic variable that holds the active PSRemoteClient, or nil if working locally.!

DynamicVariable subclass: #PSReplicateSystemEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Network'!

!PSReplicateSystemEvents commentStamp: 'mt 9/14/2010 17:08:36.551' prior: 0!
I am used to enable or disable system notification processing in PSLocalClient >> processNotification:.!

WorldState subclass: #PSRemoteWorldState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Morphic'!

!PSRemoteWorldState commentStamp: 'mt 9/7/2010 12:14:23.771' prior: 0!
I have my own queue with deferred UI messages. My dynamic scope is changed to the remote client of the corresponding remote world in EVERY update cycle.!

!PSRemoteWorldState methodsFor: 'update cycle' stamp: 'mt 9/20/2010 17:35:14.43'!
doOneCycleFor: aRemoteWorld

	PSCurrentRemoteClient
		value: aRemoteWorld remoteClient
		during: [super doOneCycleFor: aRemoteWorld].! !

!ClassOrganizer methodsFor: '*polysource-core' stamp: 'mt 10/1/2010 15:59:54.31'!
postCopy
	"Do not share vars on copy."
	
	categoryArray := categoryArray copy.
	categoryStops := categoryStops copy.
	elementArray := elementArray copy.
	subject := nil.! !

TestCase subclass: #PSBasicTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSBasicTestCase methodsFor: 'tests' stamp: 'mt 10/1/2010 12:19:37.609'!
test01new

	| sut |
	sut := PSSystemDictionary new.

	self assert: sut size equals: Smalltalk globals size - PSSystemDictionaryProxy sharedGlobals size.

	sut keysAndValuesDo: [:symbol :classTraitOrGlobal |
		(classTraitOrGlobal isBehavior
			and: [classTraitOrGlobal isTrait not]
			and: [classTraitOrGlobal superclass notNil])
			ifTrue: [self assert: classTraitOrGlobal superclass == (sut at: (classTraitOrGlobal superclass name))]].! !

!PSBasicTestCase methodsFor: 'tests' stamp: 'mig 8/10/2010 13:59:49.758'!
test02proxy

	| testCase sut root |
	
	sut := PSSystemDictionaryProxy new.
	root := Smalltalk globals.
	
	testCase := Smalltalk globals at: #TestCase.
	
	sut install.
	self assert: sut == Smalltalk globals.
	self assert: testCase == (Smalltalk globals at: #TestCase).
	sut uninstall.
	self assert: root == Smalltalk globals.! !

!PSBasicTestCase methodsFor: 'tests' stamp: 'mt 9/15/2010 12:25:18.955'!
test03proxyWithOrganization

	PSSystemDictionaryProxy install.
	
	self
		assert: Smalltalk globals isProxy;
		assert: SystemOrganization isProxy;
		assert: Smalltalk globals organization == SystemOrganization.
		
	PSSystemDictionaryProxy uninstall.
	
	self
		deny: Smalltalk globals isProxy;
		deny: SystemOrganization isProxy;
		assert: Smalltalk globals organization == SystemOrganization.! !

!PSBasicTestCase methodsFor: 'tests' stamp: 'mt 9/15/2010 12:38:14.158'!
test04doubleProxy

	"Clean up"	
	[Smalltalk globals isProxy] whileTrue: [PSSystemDictionaryProxy uninstall].

	PSSystemDictionaryProxy install.
	PSSystemDictionaryProxy install.
		
	PSSystemDictionaryProxy uninstall.
	self deny: Smalltalk globals isProxy.! !

!PSBasicTestCase methodsFor: 'tests' stamp: 'mt 9/15/2010 12:35:14.388'!
test05duplicateProxyInstallation

	"Clean up"	
	[Smalltalk globals isProxy] whileTrue: [PSSystemDictionaryProxy uninstall].

	PSSystemDictionaryProxy install.
	
	"Duplicate installation of same proxy."
	Smalltalk globals install.

	self assert: Smalltalk globals isInstalled.
	
	PSSystemDictionaryProxy uninstall.
	
	self deny: Smalltalk globals isProxy.! !

TestCase subclass: #PSModelTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/10/2010 11:16:19.694'!
test01snapshots

	| src clt |
	clt := PSRemoteClient new.
	src := PSSourceCode new.

	PSSystemDictionaryProxy install.
	clt sourceCode: src.
	PSSystemDictionaryProxy uninstall.
	
	src addPackage: #PolySource.
		
	self assert: src snapshot isNil.
	
	clt updateSnapshot.
	
	self
		assert: clt sourceCode categories size equals: src snapshot size;
		assert: (src snapshot includesKey: #'PolySource-Core');
		assert: (src snapshot includesKey: #'PolySource-Model');
		assert: (src snapshot associations first value isString).
		
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:07:39.092'!
test02classAddedEvent

	| evt upd |
	evt := AddedEvent item: String kind: #class.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String definition equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:07:47.941'!
test03classModifiedEvent

	| evt upd |
	evt := ModifiedClassDefinitionEvent classDefinitionChangedFrom: String to: Integer.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: Integer name equals: upd eventItemClass;
		assert: Integer definition equals: upd event item;
		assert: String name equals: upd event oldItem.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:07:53.435'!
test04classRemovedEvent

	| evt upd |
	evt := RemovedEvent item: String kind: #class.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String name equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:07:59.233'!
test05classRenamedEvent

	| evt upd |
	evt := RenamedEvent class: String category: #'Collections-Strings' oldName: #String newName: #NewString.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String name equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:08:06.033'!
test06classCommentedEvent

	| evt upd |
	evt := CommentedEvent item: String kind: #class.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String comment equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:08:11.905'!
test07classRecategorizedEvent

	| evt upd |
	evt := RecategorizedEvent class: String category: #Foobar oldCategory: #'Collections-Strings'.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String name equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 11:09:29.308'!
test08classReorganizedEvent

	| evt upd |
	evt := ReorganizedEvent item: String kind: #class.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String organization asString equals: upd event item.! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:08:28.143'!
test09methodAddedEvent

	| evt upd |
	evt := AddedEvent item: String>>#stringhash kind: #method.
	evt itemClass: String.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: #stringhash equals: upd eventItemMethod;
		assert: (upd event item includesSubString: evt item getSource).
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:08:34.248'!
test10methodModifiedEvent

	| evt upd |
	evt := ModifiedEvent methodChangedFrom: String>>#stringhash to: String>>#withCRs selector: #withCRs inClass: String.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: #withCRs equals: upd eventItemMethod;
		assert: #stringhash equals: upd event oldItem;
		assert: (upd event item includesSubString: evt item getSource).
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 11:23:34.906'!
test11methodRecategorizedEvent

	| evt upd |
	evt := RecategorizedEvent method: String>>#withCRs protocol: #testing class: String oldProtocol: #printing. 
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: #withCRs equals: upd eventItemMethod;
		assert: #withCRs equals: upd event item;
		assert: #testing equals: upd event itemProtocol;
		assert: #printing equals: upd event oldCategory.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:08:47.352'!
test12methodRemovedEvent

	| evt upd |
	evt := RemovedEvent item: String>>#stringhash kind: #method.
	evt itemClass: String.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: #stringhash equals: upd eventItemMethod;
		assert: #stringhash equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 11:00:02.476'!
test13repositoryStoresPackages

	| repo |
	repo := PSSourceCodeRepository new.
	
	self assert: repo packages isEmpty.
	
	repo addPackage: #XYGame.
	
	self
		assert: 1 equals: repo packages size;
		assert: #XYGame equals: repo packages first.! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 11:02:26.555'!
test14repositoryDistributesPackages

	| repo src |
	repo := PSSourceCodeRepository new.
	repo addPackage: #XYGame.
	
	src := PSSourceCode new.
	repo addSourceCode: src.
		
	self
		assert: 1 equals: src packages size;
		assert: #XYGame equals: src packages first.
		
	src addPackage: #PolySource.
	
	self assert: 2 equals: src packages size.
! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 11:27:49.634'!
test15repositoryDistributesChangedPackages

	| repo src |
	repo := PSSourceCodeRepository new.
	repo addPackage: #XYGame.	
	src := PSSourceCode new.
	repo addSourceCode: src.
	repo addPackage: #PolySource.
		
	self
		assert: 2 equals: repo packages size;
		assert: 2 equals: src packages size.! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 11:19:18.247'!
test16noDuplicatePackages

	| repo src |
	repo := PSSourceCodeRepository new.
	repo
		addPackage: #XYGame;
		addPackage: #XYGame.	
	src := PSSourceCode new.
	src
		addPackage: #XYGame;
		addPackage: #XYGame.
		
	self
		assert: 1 equals: repo packages size;
		assert: 1 equals: src packages size.! !

TestCase subclass: #PSProxiedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

PSProxiedTestCase subclass: #PSLocalClientTestCase
	instanceVariableNames: 'sut localClients event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSLocalClientTestCase methodsFor: 'running' stamp: 'mt 9/20/2010 12:27:12.636'!
createNewLocalClient
	"Repository will be shared."
	
	| client |
	client := PSLocalClient new.
	client disableNotificationProcessing.
	
	client connection: (PSSqSyncConnectionMock new
		repository: sut connection repository).
		
	localClients add: client.
		
	^ client! !

!PSLocalClientTestCase methodsFor: 'running' stamp: 'mt 9/20/2010 12:21:21.3'!
setUp

	super setUp.
	
	(PackageOrganizer default packageNames includes: #XYGame)
		ifFalse: [Error signal: 'You need the package ''XYGame'' to let these tests pass.'].
	
	localClients := OrderedCollection new.
	
	sut := PSLocalClient new.
	sut disableNotificationProcessing. "Not now."
	sut connection: PSSqSyncConnectionMock new.! !

!PSLocalClientTestCase methodsFor: 'running' stamp: 'mt 9/20/2010 12:31:37.885'!
tearDown

	sut disconnect.		
	localClients do: [:lc | lc disconnect].
	
	super tearDown.! !

!PSLocalClientTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 12:30:47.97'!
test01startup

	| newClient |
	newClient := PSLocalClient new disableNotificationProcessing.
	
	self
		assert: nil equals: newClient connection;
		assert: nil equals: newClient repository;
		assert: nil equals: newClient sourceCode;
		assert: nil equals: newClient remoteClients;
		assert: (newClient uuid isKindOf: UUID).! !

!PSLocalClientTestCase methodsFor: 'tests' stamp: 'mt 9/14/2010 17:34:00.438'!
test02uuid
	"The accessor for the uuid is idempotent."
	
	self assert: sut uuid equals: sut uuid.! !

!PSLocalClientTestCase methodsFor: 'tests' stamp: 'mt 9/14/2010 19:58:53.384'!
test03emptySourceCode
	"There is a new empty source code object. Only the author and the uuid should be set."
	
	self
		assert: sut sourceCode packages isEmpty;
		assert: sut sourceCode snapshot isEmpty;
		assert: sut sourceCode updates isEmpty;
		assert: sut uuid equals: sut sourceCode uuid;
		assert: Utilities authorInitials equals: sut sourceCode author.! !

!PSLocalClientTestCase methodsFor: 'tests' stamp: 'mt 9/15/2010 09:52:06.377'!
test04addPackageToSourceCode

	| spy |
	spy := SignalSpy onSender: sut sourceCode signal: #packageAdded:.
	
	sut addPackage: #XYGame.
	
	self
		assert: 1 equals: sut sourceCode packages size;
		assert: (PackageInfo named: #XYGame) systemCategories equals: sut sourceCode categories asArray;
		assert: {#packageAdded:. {#XYGame}} equals: spy waitForNextSignal;
		assert: sut sourceCode categories sorted equals: sut sourceCode snapshot keys sorted asOrderedCollection;
		assert: (sut sourceCode snapshot values allSatisfy: [:source | source isString]).! !

!PSLocalClientTestCase methodsFor: 'tests' stamp: 'mt 9/14/2010 20:13:11.472'!
test05duplicateUuids

	| oldRepo |
	self assert: 1 equals: sut repository sourceCodes size.
	sut sourceCode uuid: sut uuid asString. "This is the point!! =)"
	self assert: 1 equals: sut repository sourceCodes size.
	
	"Change connection but re-use the repository."
	oldRepo := sut connection repository.
	sut connection: PSSqSyncConnectionMock new.
	sut connection repository: oldRepo. 
	
	self assert: 1 equals: sut repository sourceCodes size.
	sut sourceCode.
	self assert: 1 equals: sut repository sourceCodes size.! !

!PSLocalClientTestCase methodsFor: 'tests' stamp: 'mt 9/15/2010 09:26:09.002'!
test06remoteClients

	self
		assert: 1 equals: sut repository sourceCodes size;
		assert: sut remoteClients isEmpty.
	
	"New external client."	
	self createNewLocalClient.
	
	self
		assert: 2 equals: sut repository sourceCodes size;
		assert: 1 equals: sut remoteClients size.
! !

!PSLocalClientTestCase methodsFor: 'tests' stamp: 'mt 9/17/2010 13:09:50.194'!
test07remoteClientGlobals

	| remoteClient |
	sut addPackage: #XYGame.
	
	"New external client to create a remote client in sut."	
	(self createNewLocalClient) addPackage: #XYGame.
	
	remoteClient := sut remoteClients first.
	
	self
		assert: remoteClient sourceCode snapshot notEmpty;
		assert: (remoteClient systemDictionary at: #XYPlayer) ~~ (Smalltalk at: #XYPlayer)! !

!PSLocalClientTestCase methodsFor: 'tests' stamp: 'mt 10/1/2010 16:17:27.62'!
test08events

	sut enableNotificationProcessing.
	self fail.! !

!PSProxiedTestCase methodsFor: 'running' stamp: 'mt 9/20/2010 12:35:28.818'!
setUp

	super setUp.
	PSSystemDictionaryProxy install.! !

!PSProxiedTestCase methodsFor: 'running' stamp: 'mt 9/20/2010 12:35:32.598'!
tearDown

	Smalltalk globals uninstall.
	super tearDown.! !

PSProxiedTestCase subclass: #PSRemoteClientTestCase
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSRemoteClientTestCase methodsFor: 'support' stamp: 'mt 10/1/2010 14:38:35.496'!
createExtension

	(Smalltalk at: #String)
		compile: 'xygameFoobar
	"This is an auto-generated method for PolySource extension tests."
	
	^ #blubb'
		classified: #'*xygame'.! !

!PSRemoteClientTestCase methodsFor: 'support' stamp: 'mt 10/1/2010 14:38:52.628'!
getExtension

	^ (PackageInfo named: #XYGame) extensionMethods
		detect: [:ref | ref actualClass = (Smalltalk at: #String)]
		ifNone: [nil]! !

!PSRemoteClientTestCase methodsFor: 'support' stamp: 'mt 10/1/2010 14:39:04.935'!
removeExtension

	(Smalltalk at: #String) removeSelector: #xygameFoobar.
	(Smalltalk at: #String) organization removeEmptyCategories.! !

!PSRemoteClientTestCase methodsFor: 'running' stamp: 'mt 9/30/2010 09:57:09.272'!
setUp

	(PackageOrganizer default packageNames includes: #XYGame)
		ifFalse: [Error signal: 'You need the package ''XYGame'' to let these tests pass.'].

	super setUp.
	sut := PSRemoteClient new.! !

!PSRemoteClientTestCase methodsFor: 'tests' stamp: 'mt 9/17/2010 12:06:08.442'!
test01subclasses

	"All classes are present."
	self assert: (Smalltalk classNames select: [:classname | (Smalltalk at: classname) subclasses notEmpty]) sorted equals: sut subclassesMap keys sorted.

	"No duplicate entries."	
	sut subclassesMap keysAndValuesDo: [:classname :subclasses |
		self assert: subclasses size equals: subclasses asSet size].
	
		! !

!PSRemoteClientTestCase methodsFor: 'tests' stamp: 'mt 10/1/2010 16:05:09.759'!
test02subclassesForClass

	self
		assert: Object subclasses size equals: (sut subclassesFor: Object) size;
		deny: Object subclasses == (sut subclassesFor: Object);
		deny: (sut subclassesFor: Object) == (sut subclassesFor: Object).
		! !

!PSRemoteClientTestCase methodsFor: 'tests' stamp: 'mt 9/17/2010 12:07:47.616'!
test03addSubclass

	self deny: ((sut subclassesFor: Morph) includes: Object).
	sut addSubclass: Object to: Morph. "cyclic"
	self assert: ((sut subclassesFor: Morph) includes: Object).! !

!PSRemoteClientTestCase methodsFor: 'tests' stamp: 'mt 9/17/2010 12:12:02.499'!
test04resetSubclasses

	self deny: (sut subclassesFor: Morph) isEmpty.
	sut resetSubclassesFor: Morph.
	self deny: (sut subclassesMap includesKey: #Morph).
	self assert: (sut subclassesFor: Morph) isEmpty.
! !

!PSRemoteClientTestCase methodsFor: 'tests' stamp: 'mt 9/17/2010 12:12:42.454'!
test05removeSubclass

	sut resetSubclassesFor: Morph.
	self deny: (sut subclassesMap includesKey: #Morph).

	sut addSubclass: Object to: Morph.
	sut removeSubclass: Object from: Morph.
	
	self assert: (sut subclassesFor: Morph) isEmpty.
	self deny: (sut subclassesMap includesKey: #Morph).
! !

!PSRemoteClientTestCase methodsFor: 'tests' stamp: 'mt 10/1/2010 16:04:39.53'!
test06noDuplicateSubclasses

	| size objectClassCopy morphClassCopy |
	objectClassCopy := sut systemDictionary at: #Object.
	morphClassCopy := sut systemDictionary at: #Morph.
	size := (sut subclassesFor: objectClassCopy) size.
		
	self assert: ((sut subclassesFor: objectClassCopy) includes: morphClassCopy).
	sut addSubclass: morphClassCopy to: objectClassCopy. "Already there."
	self assert: size equals: (sut subclassesFor: objectClassCopy) size.! !

!PSRemoteClientTestCase methodsFor: 'tests' stamp: 'mt 9/30/2010 10:41:45.213'!
test07hideClasses

	"Share a local package but keep the snapshot empty."
	sut sourceCode: PSSourceCode new.
	sut sourceCode addPackage: #XYGame.
	sut resetSystemVariables. "Trigger manually to avoid updating the snapshot."
	
	self assert: (Smalltalk includesKey: #XYPlayer).
	
	PSCurrentRemoteClient value: sut during: [
		self deny: (Smalltalk includesKey: #XYPlayer)].
	! !

!PSRemoteClientTestCase methodsFor: 'tests' stamp: 'mt 10/1/2010 10:07:48.922'!
test08hideExtensions

	self createExtension.
	self assert: self getExtension notNil.
	
	"Share a local package but keep the snapshot empty."
	sut sourceCode: PSSourceCode new.
	sut sourceCode addPackage: #XYGame.
	sut resetSystemVariables. "Trigger manually to avoid updating the snapshot."
	
	PSCurrentRemoteClient value: sut during: [
		self assert: self getExtension isNil].
	
	self assert: self getExtension notNil.
	self removeExtension.
	self assert: self getExtension isNil.! !

!PSRemoteClientTestCase methodsFor: 'tests' stamp: 'mt 9/30/2010 13:45:10.542'!
test09createExtension
	
	self removeExtension. "In case it is still there."
	self assert: self getExtension isNil.
	
	PSCurrentRemoteClient value: sut during: [
		self createExtension.
		self assert: self getExtension notNil].
	
	self assert: self getExtension isNil.! !

PSProxiedTestCase subclass: #PSSystemTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSSystemTestCase methodsFor: 'private' stamp: 'mt 9/20/2010 12:34:44.205'!
createTestClass

	Object
		subclass: #PSFoobar
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'PolySource-Tests-Temporary'.! !

!PSSystemTestCase methodsFor: 'private' stamp: 'mt 9/20/2010 12:34:41.677'!
getTestClass

	^ Smalltalk at: #PSFoobar! !

!PSSystemTestCase methodsFor: 'private' stamp: 'mt 9/20/2010 12:34:34.886'!
removeTestClass

	self getTestClass removeFromSystem: false.! !

!PSSystemTestCase methodsFor: 'running' stamp: 'mt 9/20/2010 12:35:02.702'!
setUp

	super setUp.
	Smalltalk at: #PSTestGlobal put: Morph new.! !

!PSSystemTestCase methodsFor: 'running' stamp: 'mt 9/20/2010 12:35:23.116'!
tearDown

	Smalltalk removeKey: #PSTestGlobal.
	super tearDown.! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 12:34:11.325'!
test01environment

	| newRemoteClient |
	newRemoteClient := PSRemoteClient new.
	
	PSCurrentRemoteClient value: newRemoteClient during: [
		self assert: Object environment yourself == newRemoteClient systemDictionary].
	self deny: Object environment yourself == newRemoteClient systemDictionary.
! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 9/30/2010 16:24:51.487'!
test02newClasses

	self deny: (Smalltalk includesKey: #PSFoobar).
	self deny: (Smalltalk includesKey: #PSFoobar2).
	
	PSCurrentRemoteClient value: PSRemoteClient new during: [
		"Create a class and a subclass of it."
		self createTestClass.
		(Smalltalk at: #PSFoobar)
			subclass: #PSFoobar2 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		self assert: (Smalltalk includesKey: #PSFoobar).
		self assert: (Smalltalk includesKey: #PSFoobar2)].
	
	self deny: (Smalltalk includesKey: #PSFoobar).
	self deny: (Smalltalk includesKey: #PSFoobar2).
! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 12:34:15.407'!
test03evaluate

	self deny: (Smalltalk includesKey: #PSFoobar).
	
	PSCurrentRemoteClient value: PSRemoteClient new during: [
		"Create a class and instantiate it once."
		self createTestClass.
		self
			shouldnt: [Compiler evaluate: 'PSFoobar new']
			raise: MessageNotUnderstood].
		
	self
		should: [Compiler evaluate: 'PSFoobar new']
		raise: MessageNotUnderstood.
! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 12:34:17.335'!
test05proxyTest

	PSSystemDictionaryProxy uninstall.
	self deny: Smalltalk globals isProxy.

	PSSystemDictionaryProxy install.
	self assert: Smalltalk globals isProxy.! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 12:34:19.171'!
test06organization

	PSCurrentRemoteClient value: PSRemoteClient new during: [
		| foobar foobar2 |
		self createTestClass.
		foobar := Compiler evaluate: 'PSFoobar'.
		foobar subclass: #PSFoobar2 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		foobar2 := Compiler evaluate: 'PSFoobar2'.
		self assert: #'PolySource-Tests-Temporary' equals: foobar category.
		self assert: #'PolySource-Tests-Temporary' equals: foobar2 category.
	].! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 12:34:21.321'!
test07newRemoteClientError

	PSCurrentRemoteClient value: #foobar during: [
		self should: [PSRemoteClient new] raise: Error].
	
	self shouldnt: [PSRemoteClient new] raise: Error.! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 12:34:23.539'!
test08globals

	| t1 t2 t3 |
	t1 := Compiler evaluate: 'PSTestGlobal'. "Transcript cr; show: 't1 ', t1 identityHash asString."
	
	PSCurrentRemoteClient
		value: PSRemoteClient new
		during: [
			"t2 := self transcript. Transcript cr; show: 't2 ', t2 identityHash asString."
			t2 := Compiler evaluate: 'PSTestGlobal'. "Transcript cr; show: 't2 ', t2 identityHash asString."
			"Transcript cr; show: 'BEGIN CHANGE VAR'."
			Smalltalk at: #PSTestGlobal put: Morph new.
			"PSTestGlobal := Morph new."
			"Transcript cr; show: 'END CHANGE VAR'."
			t3 := Compiler evaluate: 'PSTestGlobal'. "Transcript cr; show: 't3 ', t3 identityHash asString."
			"t3 := PSTestGlobal. Transcript cr; show: 't3 ', t3 identityHash asString."
			
			self assert: t2 ~~ t3].
		
	self
		assert: t1 == t2;
		assert: t2 ~~ t3;
		assert: t3 ~~ (Compiler evaluate: 'PSTestGlobal');
		assert: (Compiler evaluate: 'PSTestGlobal') == t1.! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 12:34:25.307'!
test09globalsWithNilScope

	| t1 t2 |
	t1 := Compiler evaluate: 'PSTestGlobal'.
	Smalltalk at: #PSTestGlobal put: Morph new.
	t2 := Compiler evaluate: 'PSTestGlobal'.
		
	self assert: t1 ~~ t2.! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 12:34:27.295'!
test10globalsWithScope

	PSCurrentRemoteClient
		value: PSRemoteClient new
		during: [self test09globalsWithNilScope].! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 9/20/2010 12:34:29.605'!
test11subclasses

	self deny: (Smalltalk includesKey: #PSFoobar).

	PSCurrentRemoteClient value: PSRemoteClient new during: [
		self createTestClass.
		self assert: (Object subclasses includes: self getTestClass)].
	
	self assert: (Object subclasses noneSatisfy: [:subclass | subclass name = #PSFoobar]).! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mig 9/20/2010 14:49:57.129'!
test12forkedProcesses

	| remoteClient |
	remoteClient := PSRemoteClient new.
	PSCurrentRemoteClient
		value: remoteClient
		during: [
			self assert: remoteClient equals: PSCurrentRemoteClient value.
			[self assert: remoteClient equals: PSCurrentRemoteClient value] fork].! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 10/1/2010 14:34:08.493'!
test13copyClass

	| copy |
	copy := XYPlayer copy.
	XYPlayer compile: 'name: aString' classified: #accessing.
	XYPlayer compile: 'age: anInteger' classified: #accessing.
	copy compile: 'age: anInteger' classified: #private.
	copy compile: 'highscore: anInteger' classified: #scoring.
	
	self
		"method dictionary copy"
		assert: XYPlayer methodDict ~~ copy methodDict;
		assert: (XYPlayer methodDict includesKey: #name:);
		deny: (copy methodDict includesKey: #name:);
		assert: (XYPlayer >> #age:) ~~ (copy >> #age:);
		"organization copy"
		assert: XYPlayer equals: XYPlayer organization subject;
		assert: copy equals: copy organization subject;

		assert: (copy organization categoryOfElement: #name:) isNil;
		assert: #accessing equals: (XYPlayer organization categoryOfElement: #name:);

		assert: (XYPlayer organization categoryOfElement: #highscore:) isNil;
		assert: #scoring equals: (copy organization categoryOfElement: #highscore:);

		assert: #private equals: (copy organization categoryOfElement: #age:);
		assert: #accessing equals: (XYPlayer organization categoryOfElement: #age:);
		"metaclass copy"
		assert: XYPlayer class ~~ copy class;
		assert: XYPlayer class equals: XYPlayer class organization subject;
		assert: copy class equals: copy class organization subject.
	
	XYPlayer removeSelector: #name:.
	XYPlayer removeSelector: #age:.
	XYPlayer organization removeEmptyCategories.! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 10/1/2010 15:58:51.714'!
test14copyStringClass

	| copy |
	copy := String copy.
	
	self
		"method dictionary copy"
		assert: String methodDict ~~ copy methodDict;
		assert: String binding equals: (String >> #displayAt:) methodClassAssociation; 
		"organization copy"
		assert: String equals: String organization subject;
		assert: copy equals: copy organization subject;
		"metaclass copy"
		assert: String class ~~ copy class;
		assert: String class equals: String class organization subject;
		assert: copy class equals: copy class organization subject.! !

!PSSystemTestCase methodsFor: 'tests' stamp: 'mt 10/1/2010 15:59:33.581'!
test15copyOrganization

	| copy |
	copy := String organization copy.
	
	self
		assert: nil equals: copy subject;
		assert: copy elementArray ~~ String organization elementArray.! !

ProtoObject subclass: #PSProxy
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSProxy class methodsFor: 'support' stamp: 'mt 9/17/2010 11:12:09.754'!
fixEnvironment
	"Fix inconsistent environment in classes."

	Smalltalk globals isProxy ifTrue: [PSSystemDictionaryProxy uninstall].

	Smalltalk allClasses
		select: [:c | c environment ~~ Smalltalk globals]
		thenDo: [:c | 
			Transcript cr; show: c.
			c environment: nil].! !

!PSProxy class methodsFor: 'support' stamp: 'mt 9/17/2010 10:38:48.388'!
fixSubclasses
	"Fix inconsistent subclass references for Object."

	Object subclasses do: [:class |
		(Smalltalk globals includesKey: class name) ifFalse: [
			Object removeSubclass: class. Transcript cr; show: class]].! !

!PSProxy class methodsFor: 'support' stamp: 'mt 10/1/2010 15:59:15.939'!
fixSubclassesDuplicates

	Smalltalk allClasses do: [:class |
		class subclasses size ~= class subclasses asSet size
			ifTrue: [class instVarNamed: #subclasses put: (class subclasses asSet asArray).
				Transcript cr; show: class]].! !

!PSProxy class methodsFor: 'installation' stamp: 'mt 9/15/2010 12:52:32.953'!
install

	PSSystemDictionaryProxy install.! !

!PSProxy methodsFor: 'installation' stamp: 'mt 9/15/2010 12:50:44.551'!
install

	self subclassResponsibility.! !

!PSProxy methodsFor: 'testing' stamp: 'mt 9/15/2010 12:45:49.565'!
isInstalled

	^ self object == self or: [self object isProxy]! !

!PSProxy methodsFor: 'testing' stamp: 'mt 9/15/2010 12:43:04.926'!
isProxy

	^ true! !

!PSProxy methodsFor: 'accessing' stamp: 'mt 9/15/2010 12:44:32.466'!
object

	self subclassResponsibility.! !

!PSProxy methodsFor: 'original' stamp: 'mt 9/15/2010 12:48:50.432'!
resetOriginal

	original := nil.! !

!PSProxy methodsFor: 'original' stamp: 'mt 9/15/2010 12:48:32.836'!
saveOriginal

	original := self object.! !

!PSProxy methodsFor: 'installation' stamp: 'mt 9/15/2010 12:50:50.13'!
uninstall

	self subclassResponsibility.! !

PSProxy subclass: #PSSystemDictionaryProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemDictionaryProxy commentStamp: 'mig 9/8/2010 11:42:22.872' prior: 0!
I am a proxy for the system dictionary, ie. 'Smalltalk globals'.!

!PSSystemDictionaryProxy class methodsFor: 'installation' stamp: 'mig 8/9/2010 17:42:02.667'!
install

	self new install.! !

!PSSystemDictionaryProxy class methodsFor: 'constants' stamp: 'mt 9/22/2010 11:31:00.977'!
sharedGlobals

	^ #(ActiveEvent ActiveHand ActiveWorld Display Processor Smalltalk Sensor Transcript World)! !

!PSSystemDictionaryProxy class methodsFor: 'installation' stamp: 'mig 8/9/2010 17:42:35.209'!
uninstall

	Smalltalk globals uninstall.! !

!PSSystemDictionaryProxy methodsFor: 'proxy' stamp: 'mt 10/1/2010 16:14:50.122'!
doesNotUnderstand: aMessage

	original ifNil: [^ aMessage sendTo: Smalltalk globals "^ super doesNotUnderstand: aMessage"].
	
	"Take care of shared global variables."
	(aMessage arguments notEmpty and: [self class sharedGlobals includes: aMessage arguments first])
		ifTrue: [^ aMessage sendTo: original].
	
	^ aMessage sendTo: (PSCurrentRemoteClient value
		ifNil: [original]
		ifNotNil: [PSCurrentRemoteClient value systemDictionary])! !

!PSSystemDictionaryProxy methodsFor: 'installation' stamp: 'mt 9/17/2010 11:14:40.955'!
install

	self isInstalled ifTrue: [^self].

	self saveOriginal.
	Smalltalk instVarNamed: #globals put: self.
	
	"Update class environment cache."
	Smalltalk allClasses
		reject: [:c | (c instVarNamed: #environment) isNil]
		thenDo: [:c | c environment: self].
	
	"Add a proxy for the organization too."
	PSSystemOrganizerProxy install.
! !

!PSSystemDictionaryProxy methodsFor: 'accessing' stamp: 'mt 9/15/2010 12:44:42.426'!
object

	^ Smalltalk globals! !

!PSSystemDictionaryProxy methodsFor: 'installation' stamp: 'mt 9/17/2010 11:15:15.889'!
uninstall

	self isInstalled ifFalse: [^self].

	Smalltalk instVarNamed: #globals put: original.
	
	"Update class environment cache."
	Smalltalk allClasses
		reject: [:c | (c instVarNamed: #environment) isNil]
		thenDo: [:c | c environment: original].
	
	"Forget about the original."
	self resetOriginal.
	
	"Remove proxy for organization."
	PSSystemOrganizerProxy uninstall.! !

PSProxy subclass: #PSSystemOrganizerProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemOrganizerProxy commentStamp: 'mig 9/8/2010 11:42:10.656' prior: 0!
I am a proxy for the system organizer, ie. 'Smalltalk organization'.
DO NOT install me directly but use "PSSystemDictionaryProxy install" instead.!

!PSSystemOrganizerProxy class methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:37:54.726'!
install

	self new install.! !

!PSSystemOrganizerProxy class methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:38:13.074'!
uninstall

	SystemOrganization uninstall.! !

!PSSystemOrganizerProxy methodsFor: 'proxy' stamp: 'mt 9/6/2010 11:43:40.372'!
doesNotUnderstand: aMessage

	original ifNil: [^ super doesNotUnderstand: aMessage].
	
	^ aMessage sendTo: (PSCurrentRemoteClient value 
		ifNil: [original]
		ifNotNil: [PSCurrentRemoteClient value systemOrganization])! !

!PSSystemOrganizerProxy methodsFor: 'installation' stamp: 'mt 9/15/2010 12:49:53.425'!
install

	self isInstalled ifTrue: [^self].

	self saveOriginal.
	Smalltalk at: #SystemOrganization put: self.
! !

!PSSystemOrganizerProxy methodsFor: 'accessing' stamp: 'mt 9/15/2010 12:46:08.107'!
object

	^ SystemOrganization! !

!PSSystemOrganizerProxy methodsFor: 'installation' stamp: 'mt 9/15/2010 12:49:43.557'!
uninstall

	self isInstalled ifFalse: [^self].
	
	Smalltalk at: #SystemOrganization put: original.
	self resetOriginal.! !

MorphicProject subclass: #PSRemoteProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Morphic'!

!PSRemoteProject commentStamp: 'mt 9/7/2010 12:15:12.813' prior: 0!
A remote projecte has a remote world. ;)!

!PSRemoteProject class methodsFor: 'instance creation' stamp: 'mt 9/20/2010 17:38:37.046'!
new

	PSCurrentRemoteClient value ifNil: [Error signal: 'You need to set a current remote client before a remote project can be created!!'].
	
	^ super new! !

!PSRemoteProject methodsFor: 'docking bars support' stamp: 'mt 10/1/2010 16:32:24.138'!
createOrUpdateMainDockingBar
	"Private - create a new main docking bar or update the current one"
	| w mainDockingBars |
	w := self world.
	mainDockingBars := w mainDockingBars.
	mainDockingBars isEmpty
		ifTrue: ["no docking bar, just create a new one"
			PSRemoteWorldMainDockingBar instance createDockingBar openInWorld: w.
			^ self].
	"update if needed"
	mainDockingBars
		do: [:each | PSRemoteWorldMainDockingBar instance updateIfNeeded: each]! !

!PSRemoteProject methodsFor: 'initialize' stamp: 'mt 9/20/2010 17:39:04.27'!
initialize

	self perform: #initialize withArguments: #() inSuperclass: Project.

	world := PSRemoteWorld newWorldForProject: self.
	world remoteClient: PSCurrentRemoteClient value.
	
	Locale switchToID: CurrentProject localeID.
	Preferences useVectorVocabulary ifTrue: [world installVectorVocabulary]
	! !

!PSRemoteProject methodsFor: 'accessing' stamp: 'mt 9/7/2010 13:09:47.222'!
name

	^ self world remoteClient
		ifNil: ['nil']
		ifNotNil: [self world remoteClient name]! !

!Process class methodsFor: '*polysource-core-override' stamp: 'mig 9/20/2010 15:05:35.992'!
forContext: aContext priority: anInteger 
	"Answer an instance of me that has suspended aContext at priority 
	anInteger."

	| newProcess |
	newProcess := self new.
	newProcess suspendedContext: aContext.
	newProcess priority: anInteger.
	PSCurrentRemoteClient value ifNotNilDo: [:remoteClient | 
		"same remote client as the forking process"
		newProcess environmentAt: PSCurrentRemoteClient put: remoteClient].
	^newProcess! !
PSFixtures initialize!
